---------------------------------------------------------------------------------
-- Alumne: Jessica Villamor 
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO DE VIDEOJOCS
---------------------------------------------------------------------------------

--
-- Ens situem a l'esquema de la base de dades de Gesti de Videojocs
--
ALTER SESSION SET CURRENT_SCHEMA = PFCBD;


-- Creaci de la definici del paquet
create or replace
PACKAGE  GESTIO_USUARIS AS
	FUNCTION get_hash (p_username  IN  VARCHAR2,p_password  IN  VARCHAR2) RETURN VARCHAR2;

	PROCEDURE INS_JUGADORS( p_codProv IN PFCBD.JUGADORS.CODPROV%TYPE, p_codPais IN PFCBD.JUGADORS.CODPAIS%TYPE, p_codPob IN PFCBD.JUGADORS.CODPOB%TYPE, p_dataAlta IN PFCBD.JUGADORS.DATAALTA%TYPE, 
						p_nomUsuari IN PFCBD.JUGADORS.NOMUSUARI%TYPE, p_contrasenya IN PFCBD.JUGADORS.CONTRASENYA%TYPE, p_nom IN PFCBD.JUGADORS.NOM%TYPE, p_primerCog IN PFCBD.JUGADORS.PRIMERCOG%TYPE, 
						p_segonCog IN PFCBD.JUGADORS.SEGONCOG%TYPE, p_sexe IN PFCBD.JUGADORS.SEXE%TYPE, p_mail IN PFCBD.JUGADORS.MAIL%TYPE,	p_resultat OUT VARCHAR); 

	PROCEDURE UPD_JUGADORS_PARAULA_PAS (p_nomUsuari IN PFCBD.JUGADORS.NOMUSUARI%TYPE, p_ant_contrasenya IN PFCBD.JUGADORS.CONTRASENYA%TYPE, p_nov_contrasenya IN PFCBD.JUGADORS.CONTRASENYA%TYPE, p_resultat OUT VARCHAR); 
	
	PROCEDURE CNS_JUGADORS_PARAULA_PAS (p_nomUsuari IN PFCBD.JUGADORS.NOMUSUARI%TYPE, p_contrasenya IN PFCBD.JUGADORS.CONTRASENYA%TYPE,	p_resultat OUT VARCHAR);
  
	PROCEDURE UPD_JUGADORS_BASE ( p_id IN PFCBD.JUGADORS.ID%TYPE, p_codProv IN PFCBD.JUGADORS.CODPROV%TYPE, p_codPais IN PFCBD.JUGADORS.CODPAIS%TYPE, p_codPob IN PFCBD.JUGADORS.CODPOB%TYPE, 
						p_nom IN PFCBD.JUGADORS.NOM%TYPE, p_primerCog IN PFCBD.JUGADORS.PRIMERCOG%TYPE, p_segonCog IN PFCBD.JUGADORS.SEGONCOG%TYPE, p_sexe IN PFCBD.JUGADORS.SEXE%TYPE, 
						p_mail IN PFCBD.JUGADORS.MAIL%TYPE, p_resultat OUT VARCHAR);

	PROCEDURE CNS_JUGADORS_BASE ( p_rs IN OUT sys_refcursor, p_id IN PFCBD.JUGADORS.ID%TYPE, p_nomUsuari IN PFCBD.JUGADORS.NOMUSUARI%TYPE, p_resultat OUT VARCHAR);

	PROCEDURE INS_JUGADORS_XARXES( p_xarxaId IN PFCBD.JUGADORS_XARXES.XARXES_SOCIALS_ID%TYPE, p_jugadorId IN PFCBD.JUGADORS_XARXES.JUGADORS_ID%TYPE, p_nomUsuari IN PFCBD.JUGADORS_XARXES.NOMUSUARI%TYPE,
							   p_contrasenya IN PFCBD.JUGADORS_XARXES.CONTRASENYA%TYPE, p_dataAlta IN PFCBD.JUGADORS_XARXES.DATAALTA%TYPE, p_resultat OUT VARCHAR);

	PROCEDURE UPD_JUGADORS_XARXES( p_id IN PFCBD.JUGADORS_XARXES.ID%TYPE, p_xarxaId IN PFCBD.JUGADORS_XARXES.XARXES_SOCIALS_ID%TYPE, p_jugadorId IN PFCBD.JUGADORS_XARXES.JUGADORS_ID%TYPE,	   
							   p_nomUsuari IN PFCBD.JUGADORS_XARXES.NOMUSUARI%TYPE, p_contrasenya IN PFCBD.JUGADORS_XARXES.CONTRASENYA%TYPE,  p_resultat OUT VARCHAR);

	PROCEDURE BX_JUGADORS_XARXES( p_id IN PFCBD.JUGADORS_XARXES.ID%TYPE, p_dataBaixa IN PFCBD.JUGADORS_XARXES.DATABAIXA%TYPE, p_resultat OUT VARCHAR);

	PROCEDURE CNS_JUGADORS_XARXES ( p_rs OUT sys_refcursor, p_id IN PFCBD.JUGADORS_XARXES.ID%TYPE, p_xarxaId IN PFCBD.JUGADORS_XARXES.XARXES_SOCIALS_ID%TYPE, p_JugadorId IN PFCBD.JUGADORS_XARXES.JUGADORS_ID%TYPE, p_resultat OUT VARCHAR);
	
END GESTIO_USUARIS;
/


-- Creaci del cos del paquet
CREATE OR REPLACE PACKAGE BODY PFCBD.GESTIO_USUARIS AS

---------------------------------------------------------------------------------
-- Procediments CU01: Gesti d'usuari
---------------------------------------------------------------------------------

---------------------------------------------------------------------------------
-- Funci com per obtenir les paraules de pas ofuscades
-- Parmetres d'entrada: 
-- 				p_username: Cadena de carcters amb el nom d'usuari
--				p_password: Cadena de carcters amb la paraula de pass
-- Retorna la paraula de pas ofuscada	
---------------------------------------------------------------------------------
	FUNCTION get_hash (p_username IN VARCHAR2,
                       p_password IN VARCHAR2)
    RETURN VARCHAR2 AS
    l_salt VARCHAR2(30) := 'PFCBD';
		BEGIN
    RETURN DBMS_OBFUSCATION_TOOLKIT.MD5(
      input_string => UPPER(p_username) || l_salt || UPPER(p_password));
	END get_hash;
---------------------------------------------------------------------------------  
   
  
  
---------------------------------------------------------------------------------  
-- CU01-01: Alta Usuari
-- Parmetres d'entrada:
--		* p_codProv: Codi de Provincia
--		* p_codPais: Codi de Pas
--		* p_codPob: Codi de Poblaci
--		* p_dataAlta: Data d'alta
--		* p_nomUsuari: Nom del nou usuari
--		* p_contrasenya: Contrasenya de l'usuari
--		* p_nom: Nom del Jugador
--		* p_primerCog: Primer Cognom del Jugador
--		* p_segonCog: Segon Cognom del Jugador
--		* p_sexe: Sexe del Jugador
--		* p_mail: Adrea de correu electrnic
-- Parmetres de sortida: 
--		* p_resultat: Resultat del procediment OK/KO
---------------------------------------------------------------------------------
PROCEDURE INS_JUGADORS( p_codProv IN PFCBD.JUGADORS.CODPROV%TYPE, 
						p_codPais IN PFCBD.JUGADORS.CODPAIS%TYPE, 
						p_codPob IN PFCBD.JUGADORS.CODPOB%TYPE, 
						p_dataAlta IN PFCBD.JUGADORS.DATAALTA%TYPE, 
						p_nomUsuari IN PFCBD.JUGADORS.NOMUSUARI%TYPE, 
						p_contrasenya IN PFCBD.JUGADORS.CONTRASENYA%TYPE, 
						p_nom IN PFCBD.JUGADORS.NOM%TYPE, 
						p_primerCog IN PFCBD.JUGADORS.PRIMERCOG%TYPE, 
						p_segonCog IN PFCBD.JUGADORS.SEGONCOG%TYPE, 
						p_sexe IN PFCBD.JUGADORS.SEXE%TYPE, 
						p_mail IN PFCBD.JUGADORS.MAIL%TYPE,
						p_resultat OUT VARCHAR) 
IS
	v_id PFCBD.JUGADORS.ID%TYPE;

-- Valors per registrar al LOG	
	v_dataInici PFCBD.LOG.DATAINICI%TYPE;
	v_dataFi PFCBD.LOG.DATAFI%TYPE;
	v_procediment PFCBD.LOG.PROCEDIMENT%TYPE;
	v_paramEnt PFCBD.LOG.PARAMENTRADA%TYPE;
	v_paramSor PFCBD.LOG.PARAMSORTIDA%TYPE;
	v_resultat PFCBD.LOG.RESULTAT%TYPE;
  
BEGIN
	-- S'assignen els valors d'entrada
	v_dataInici        := SYSDATE;   
	v_procediment := $$PLSQL_UNIT || '.INS_JUGADORS';
	v_paramEnt       := 'p_codProv = ' || p_codProv 
                      || ', p_codPais = ' || p_codPais
					  || ', p_codPob = ' || p_codPob
					  || ', p_dataAlta = ' || p_dataAlta
					  || ', p_nomUsuari = ' || p_nomUsuari
					  || ', p_contrasenya = ' || get_hash(upper(p_nomUsuari), p_contrasenya)
					  || ', p_nom = ' || p_nom
					  || ', p_primerCog = ' || p_primerCog
					  || ', p_segonCog = ' || p_segonCog
					  || ', p_sexe = ' || p_sexe
					  || ', p_mail = ' || p_mail;

	
    -- S'inserta el nou Jugador		
      INSERT INTO JUGADORS(CODPROV, CODPAIS, CODPOB, DATAALTA, NOMUSUARI, CONTRASENYA, NOM, PRIMERCOG, SEGONCOG, SEXE, MAIL) 
      VALUES (p_codProv, upper(p_codPais), p_codPob, nvl(p_dataAlta,sysdate), upper(p_nomUsuari), get_hash(upper(p_nomUsuari), p_contrasenya) , p_nom, p_primerCog, p_segonCog, p_sexe, p_mail);

  
	-- S'omplen els valors de sortida
		p_resultat := 'OK';
		v_dataFi    := SYSDATE;
		v_paramSor	:= 'p_resultat: ' || p_resultat;
		v_resultat  := '00: Creaci de Jugador realitzada correctament.';
		  
	-- Es grava al LOG
		GESTIO_LOG.INS_LOG(v_dataInici, v_dataFi, v_procediment, v_paramEnt, v_paramSor, v_resultat);		
 
  EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE) 
                    WHEN -1 THEN
                        -- Registre duplicat
                        v_resultat := '01: Ja existeix un jugador amb el mateix nom d''usuari.';
                    WHEN -1400 THEN
                        -- Valor nul
                        v_resultat := '02: S''ha intentat inserir un valor NULL' || SUBSTR(SQLERRM,INSTR(SQLERRM,'('));
                    WHEN -02290 THEN
                        v_resultat := '02: Error en el compliment d''una regla de verificaci' || SUBSTR(SQLERRM,INSTR(SQLERRM,'('));
                    WHEN -02291 THEN
                        v_resultat := '02: Error d''integritat referencial ' || SUBSTR(SQLERRM,INSTR(SQLERRM,'('));
                    WHEN -20000 THEN
                        v_resultat := '03: Ha d''informar el nom d''usuari.';
                    WHEN -20001 THEN
                        v_resultat := '03: Ja existeix un usuari amb el mateix nom d''usuari.';	
					          ELSE
                        -- Error no controlat
                        v_resultat := '99: ' || SQLCODE || ' - ' || SQLERRM;
                END CASE;            

	-- S'assignem els valors de sortida 
	p_resultat := 'KO';
    v_dataFi    := SYSDATE;
    v_paramSor	:= 'p_resultat: ' || p_resultat;
        
	DBMS_OUTPUT.put_line (v_resultat);				
	-- Gravem al LOG
    GESTIO_LOG.INS_LOG(v_dataInici, v_dataFi, v_procediment, v_paramEnt, v_paramSor, v_resultat);	

END INS_JUGADORS;
---------------------------------------------------------------------------------


---------------------------------------------------------------------------------  
-- CU01-02: Canvi de paraula de pas
-- Parmetres d'entrada:
--		* p_nomUsuari: Nom del nou usuari
--		* p_ant_contrasenya: Paraula de pas antiga de l'usuari
--		* p_nov_contrasenya: Nova contrasenya de l'usuari
-- Parmetres de sortida: 
--		* p_resultat: Resultat del procediment OK/KO
---------------------------------------------------------------------------------
PROCEDURE UPD_JUGADORS_PARAULA_PAS (p_nomUsuari IN PFCBD.JUGADORS.NOMUSUARI%TYPE, 
									p_ant_contrasenya IN PFCBD.JUGADORS.CONTRASENYA%TYPE, 
									p_nov_contrasenya IN PFCBD.JUGADORS.CONTRASENYA%TYPE,
									p_resultat OUT VARCHAR) 
AS
	
	v_id PFCBD.JUGADORS.ID%TYPE;
	
	-- Valors per registrar al LOG	
	v_dataInici PFCBD.LOG.DATAINICI%TYPE;
	v_dataFi PFCBD.LOG.DATAFI%TYPE;
	v_procediment PFCBD.LOG.PROCEDIMENT%TYPE;
	v_paramEnt PFCBD.LOG.PARAMENTRADA%TYPE;
	v_paramSor PFCBD.LOG.PARAMSORTIDA%TYPE;
	v_resultat PFCBD.LOG.RESULTAT%TYPE;
	
  BEGIN
  
  	-- S'assignen els valors d'entrada
	v_dataInici   := SYSDATE;   
	v_procediment := $$PLSQL_UNIT || '.UPD_JUGADORS_PARAULA_PAS';
	v_paramEnt    := 'p_nomUsuari = ' || p_nomUsuari 
                   || ', p_ant_contrasenya = ' || get_hash(upper(p_nomUsuari), p_ant_contrasenya)
                   || ', p_nov_contrasenya = ' || get_hash(upper(p_nomUsuari), p_nov_contrasenya);
					  
   	SELECT ID
    INTO   v_id
    FROM   jugadors
    WHERE  NOMUSUARI = upper(p_nomUsuari)
    AND    CONTRASENYA = get_hash(upper(p_nomUsuari), p_ant_contrasenya)
    FOR UPDATE;
    
    UPDATE jugadors
    SET    CONTRASENYA = get_hash(upper(p_nomUsuari), p_nov_contrasenya)
    WHERE  id    = v_id;
    	
	-- S'omplen els valors de sortida
    p_resultat := 'OK';
    v_dataFi    := SYSDATE;
	v_paramSor	:= 'p_resultat: ' || p_resultat;
	v_resultat     := '00: Canvi realitzat correctament';
	
	-- Es grava al LOG
    GESTIO_LOG.INS_LOG(v_dataInici, v_dataFi, v_procediment, v_paramEnt, v_paramSor, v_resultat);	
	   
 
 EXCEPTION
    WHEN NO_DATA_FOUND THEN
          v_resultat := '01: Usuari/paraula de pas Incorrecta.';

	-- S'assignem els valors de sortida 
		p_resultat := 'KO';
		v_dataFi    := SYSDATE;
		v_paramSor	:= 'p_resultat: ' || p_resultat;
	
		DBMS_OUTPUT.put_line (v_resultat);				
	-- Gravem al LOG
    GESTIO_LOG.INS_LOG(v_dataInici, v_dataFi, v_procediment, v_paramEnt, v_paramSor, v_resultat);		   

END UPD_JUGADORS_PARAULA_PAS;
---------------------------------------------------------------------------------


---------------------------------------------------------------------------------
-- CU01-03: Verificar paraula de pas d'un usuari
-- Parmetres d'entrada:
--		* p_nomUsuari: Nom del nou usuari
--		* p_contrasenya: Paraula de pas
-- Parmetres de sortida: 
--		* p_resultat: Resultat del procediment OK/KO
---------------------------------------------------------------------------------
PROCEDURE CNS_JUGADORS_PARAULA_PAS (p_nomUsuari IN PFCBD.JUGADORS.NOMUSUARI%TYPE, 
									p_contrasenya IN PFCBD.JUGADORS.CONTRASENYA%TYPE,
									p_resultat OUT VARCHAR) AS
	v_id PFCBD.JUGADORS.ID%TYPE;
	
-- Valors per registrar al LOG	
	v_dataInici PFCBD.LOG.DATAINICI%TYPE;
	v_dataFi PFCBD.LOG.DATAFI%TYPE;
	v_procediment PFCBD.LOG.PROCEDIMENT%TYPE;
	v_paramEnt PFCBD.LOG.PARAMENTRADA%TYPE;
	v_paramSor PFCBD.LOG.PARAMSORTIDA%TYPE;
	v_resultat PFCBD.LOG.RESULTAT%TYPE;
	
  BEGIN
    
	-- S'assignen els valors d'entrada
	v_dataInici        := SYSDATE;   
	v_procediment := $$PLSQL_UNIT || '.CNS_JUGADORS_PARAULA_PAS';
	v_paramEnt       := 'p_nomUsuari = ' || p_nomUsuari 
       				  || ', p_contrasenya = ' || get_hash(upper(p_nomUsuari), p_contrasenya);

    SELECT ID
    INTO   v_id
    FROM   jugadors
    WHERE  NOMUSUARI = upper(p_nomUsuari)
    AND    CONTRASENYA = get_hash(upper(p_nomUsuari), p_contrasenya);
      
	
	-- S'omplen els valors de sortida
    p_resultat := 'OK';
    v_dataFi    := SYSDATE;
	v_paramSor	:= 'p_resultat: ' || p_resultat;
	v_resultat     := '00: Verificaci correcta';
      
	-- Es grava al LOG
    GESTIO_LOG.INS_LOG(v_dataInici, v_dataFi, v_procediment, v_paramEnt, v_paramSor, v_resultat);	
	
	EXCEPTION
		WHEN NO_DATA_FOUND THEN
			v_resultat := '01: Usuari/paraula de pas Incorrecta.';
		
	-- S'assignem els valors de sortida 
    p_resultat := 'KO';
    v_dataFi    := SYSDATE;
    v_paramSor	:= 'p_resultat: ' || p_resultat;
        
	DBMS_OUTPUT.put_line (v_resultat);				
	-- Gravem al LOG
    GESTIO_LOG.INS_LOG(v_dataInici, v_dataFi, v_procediment, v_paramEnt, v_paramSor, v_resultat);	
	
  END CNS_JUGADORS_PARAULA_PAS;  
---------------------------------------------------------------------------------  
  
  
---------------------------------------------------------------------------------  
-- CU01-04: Actualitzar les dades base del Jugador
-- Parmetres d'entrada:
--		* p_codProv: Codi de Provincia
--		* p_codPais: Codi de Pas
--		* p_codPob: Codi de Poblaci
--		* p_nom: Nom del Jugador
--		* p_primerCog: Primer Cognom del Jugador
--		* p_segonCog: Segon Cognom del Jugador
--		* p_sexe: Sexe del Jugador
--		* p_mail: Adrea de correu electrnic
-- Parmetres de sortida: 
--		* p_resultat: Resultat del procediment OK/KO
---------------------------------------------------------------------------------
PROCEDURE UPD_JUGADORS_BASE ( p_id IN PFCBD.JUGADORS.ID%TYPE, 
						p_codProv IN PFCBD.JUGADORS.CODPROV%TYPE, 
						p_codPais IN PFCBD.JUGADORS.CODPAIS%TYPE, 
						p_codPob IN PFCBD.JUGADORS.CODPOB%TYPE, 
						p_nom IN PFCBD.JUGADORS.NOM%TYPE, 
						p_primerCog IN PFCBD.JUGADORS.PRIMERCOG%TYPE, 
						p_segonCog IN PFCBD.JUGADORS.SEGONCOG%TYPE, 
						p_sexe IN PFCBD.JUGADORS.SEXE%TYPE, 
						p_mail IN PFCBD.JUGADORS.MAIL%TYPE,
						p_resultat OUT VARCHAR)
IS
	v_id PFCBD.JUGADORS.ID%TYPE;
	v_codProv PFCBD.JUGADORS.CODPROV%TYPE;
	v_codPais PFCBD.JUGADORS.CODPAIS%TYPE;
	v_codPob PFCBD.JUGADORS.CODPOB%TYPE;
	
-- Valors per registrar al LOG	
	v_dataInici PFCBD.LOG.DATAINICI%TYPE;
	v_dataFi PFCBD.LOG.DATAFI%TYPE;
	v_procediment PFCBD.LOG.PROCEDIMENT%TYPE;
	v_paramEnt PFCBD.LOG.PARAMENTRADA%TYPE;
	v_paramSor PFCBD.LOG.PARAMSORTIDA%TYPE;
	v_resultat PFCBD.LOG.RESULTAT%TYPE;	
BEGIN

-- S'assignen els valors d'entrada
	v_dataInici        := SYSDATE;   
	v_procediment := $$PLSQL_UNIT || '.UPD_JUGADORS_BASE';
	v_paramEnt       := 'p_id = ' || p_id 
					  || ', p_codProv = ' || p_codProv
                      || ', p_codPais = ' || p_codPais
					  || ', p_codPob = ' || p_codPob
					  || ', p_nom = ' || p_nom
					  || ', p_primerCog = ' || p_primerCog
					  || ', p_segonCog = ' || p_segonCog
					  || ', p_sexe = ' || p_sexe
					  || ', p_mail = ' || p_mail;



  BEGIN
-- Es verifica que el Jugador existeix al sistema
    IF p_id IS NOT NULL THEN
        SELECT ID into v_id
                  FROM JUGADORS
                  WHERE ID = p_id;
    END IF;
    EXCEPTION
        WHEN OTHERS THEN
             IF (SQLCODE = 100) THEN
                   -- Jugador no trobat
                   RAISE_APPLICATION_ERROR(-20000,'');
             END IF; 
		END;  
    
 BEGIN
-- Es verifica que el pas existeix al sistema
    IF p_codPais IS NOT NULL THEN
        SELECT CODPAIS into v_codPais
        FROM PAISOS
        WHERE CODPAIS = upper(p_codPais);
    END IF;
    EXCEPTION
        WHEN OTHERS THEN
             IF (SQLCODE = 100) THEN
                   -- Pas no trobat
                   RAISE_APPLICATION_ERROR(-20001,'');
             END IF; 
END;  

BEGIN
	-- Si s'introdueix codi de provncia, es verifica que existeix en el sisetma
    IF p_codProv IS NOT NULL THEN
        SELECT CODPROV into v_codProv
        FROM PROVINCIES
        WHERE CODPROV = p_codProv
              AND CODPAIS = upper(p_codPais);
    END IF;
    EXCEPTION
        WHEN OTHERS THEN
             IF (SQLCODE = 100) THEN
                   -- Provncia no trobada
                   RAISE_APPLICATION_ERROR(-20002,'');
             END IF; 
END;  

BEGIN
-- Si s'introdueix codi de poblaci, es verifica que existeix en el sistema
    IF p_codPob IS NOT NULL THEN
        SELECT CODPROV into v_codPob
        FROM POBLACIONS
        WHERE CODPROV = p_codProv
              AND CODPAIS = upper(p_codPais)
              AND CODPOB = p_codPob;
    END IF;
    EXCEPTION
        WHEN OTHERS THEN
             IF (SQLCODE = 100) THEN
                   -- Poblaci no trobada
                   RAISE_APPLICATION_ERROR(-20003,'');
             END IF; 
END;  

IF p_id IS NULL THEN 
        RAISE_APPLICATION_ERROR(-20004,'');	
 END IF;
	 
	UPDATE JUGADORS 
			SET CODPROV = p_codProv, CODPAIS = upper(p_codPais), CODPOB = p_codPob, NOM = p_nom, PRIMERCOG = p_primerCog, SEGONCOG=p_segonCog , SEXE = p_sexe, MAIL = p_mail  
			WHERE JUGADORS.ID = p_id;
	
	IF SQL%rowcount = 0
	THEN
		v_resultat := '03: Jugador no trobat amb ID = ' || p_id;
	ELSE
		v_resultat := '00: Jugador actualitzat correctament';
	END IF;
  
    -- S'omplen els valors de sortida
    p_resultat := 'OK';
    v_dataFi    := SYSDATE;
	v_paramSor	:= 'p_resultat: ' || p_resultat;
	      
	-- Es grava al LOG
    GESTIO_LOG.INS_LOG(v_dataInici, v_dataFi, v_procediment, v_paramEnt, v_paramSor, v_resultat);	

EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE)
                   WHEN -1407 THEN
                        -- Valor nulo
                        v_resultat := '02: Sha intentat inserir un valor NULL.' || SUBSTR(SQLERRM,INSTR(SQLERRM,'('));
                    WHEN -20000 THEN
                        v_resultat := '03: Jugador no trobat amb ID = ' || p_id;
                    WHEN -20001 THEN
                        v_resultat := '03: Pas no trobat amb codi ' || p_codPais;
                    WHEN -20002 THEN
                        v_resultat := '03: Provncia no trobada amb codi: ' || p_codProv || '('|| p_codPais || ')';
                    WHEN -20003 THEN
                        v_resultat := '03: Poblaci no trobada amb codi: ' || p_codPob || '/' || p_codProv || '('|| p_codPais || ')';
                    WHEN -20004 THEN
                        v_resultat := '03: Ha d''introduir l''identificador del jugador a actualitzar';
                    WHEN -02290 THEN
                        v_resultat := '02: Error en el compliment d''una regla de verificaci' || SUBSTR(SQLERRM,INSTR(SQLERRM,'('));
                    WHEN -02291 THEN
                        v_resultat := '02: Error d''integritat referencial ' || SUBSTR(SQLERRM,INSTR(SQLERRM,'('));
					          ELSE
                        -- Error no controlat
                        v_resultat := '99: ' || SQLCODE || ' - ' || SQLERRM;
				END CASE;            
  
-- S'assignem els valors de sortida 
	p_resultat := 'KO';
    v_dataFi    := SYSDATE;
    v_paramSor	:= 'p_resultat: ' || p_resultat;
        
	DBMS_OUTPUT.put_line (v_resultat);				
-- Gravem al LOG
    GESTIO_LOG.INS_LOG(v_dataInici, v_dataFi, v_procediment, v_paramEnt, v_paramSor, v_resultat);	
	   
END UPD_JUGADORS_BASE;
---------------------------------------------------------------------------------


---------------------------------------------------------------------------------
-- CU01-05: Consulta dades base del Jugador
-- Parmetres d'entrada:
--		* p_id: Identificador del Jugador
--		* p_nomUsuari: Nom d'usuari
-- Parmetres de sortida: 
-- 		* p_rs: Recordset amb el resultat
--		* p_resultat: Resultat del procediment OK/KO
--
-- Es realitzar la consulta de les dades base d'un jugador a partir del seu identificador o el seu nom d'usuari.
-- Si no s'introdueixen parmetres de selecci es retornar les dades de tots els jugadors.
---------------------------------------------------------------------------------
PROCEDURE CNS_JUGADORS_BASE ( p_rs IN OUT sys_refcursor, 	
						p_id IN PFCBD.JUGADORS.ID%TYPE, 
						p_nomUsuari IN PFCBD.JUGADORS.NOMUSUARI%TYPE, p_resultat OUT VARCHAR)
IS
	-- Valors per registrar al LOG	
	v_dataInici PFCBD.LOG.DATAINICI%TYPE;
	v_dataFi PFCBD.LOG.DATAFI%TYPE;
	v_procediment PFCBD.LOG.PROCEDIMENT%TYPE;
	v_paramEnt PFCBD.LOG.PARAMENTRADA%TYPE;
	v_paramSor PFCBD.LOG.PARAMSORTIDA%TYPE;
	v_resultat PFCBD.LOG.RESULTAT%TYPE;
BEGIN

	-- S'assignen els valors d'entrada
	v_dataInici        := SYSDATE;   
	v_procediment := $$PLSQL_UNIT || '.CNS_JUGADORS_BASE';
	v_paramEnt       := 'p_id = ' || p_id 
                      || ', p_nomUsuari = ' || p_nomUsuari;
	
  -- Consulta per extreure les dades base del jugador a partir del seu identificador
	IF p_id IS NOT NULL THEN
			OPEN p_rs FOR
			SELECT ID, CODPROV, CODPAIS, CODPOB, NOM, PRIMERCOG, SEGONCOG, SEXE, MAIL
			FROM JUGADORS
			where id = p_id;
	ELSIF p_nomUsuari IS NOT NULL THEN
	-- Consulta per extreure les dades base del jugador a partir del seu nom d'usuari	 
			OPEN p_rs FOR
			SELECT ID, CODPROV, CODPAIS, CODPOB, NOM, PRIMERCOG, SEGONCOG, SEXE, MAIL
			FROM JUGADORS
			where nomusuari = upper(p_nomUsuari);
	ELSE
	-- Consulta per extreure les dades de tots els jugadors
			OPEN p_rs FOR
			SELECT ID, CODPROV, CODPAIS, CODPOB, NOM, PRIMERCOG, SEGONCOG, SEXE, MAIL
			FROM JUGADORS;
	END IF;
			
	
	-- S'omplen els valors de sortida
    p_resultat := 'OK';
    v_dataFi    := SYSDATE;
    v_paramSor	:= 'p_resultat: ' || p_resultat || ', p_rs: Resultat de la consulta.';
    v_resultat := '00: Consulta realitzada correctament';
      
	-- Es grava al LOG
    GESTIO_LOG.INS_LOG(v_dataInici, v_dataFi, v_procediment, v_paramEnt, v_paramSor, v_resultat);	
	   
	EXCEPTION
            WHEN OTHERS THEN
				v_resultat := '99: ' || SQLCODE || ' - ' || SQLERRM;
               
	-- Es genera un recordset buit
            OPEN p_rs FOR
            SELECT * FROM DUAL WHERE DUMMY IS NULL;	   
			
	-- S'assignem els valors de sortida 
		p_resultat := 'KO';
		v_dataFi    := SYSDATE;
		v_paramSor	:= 'p_resultat: ' || p_resultat || ', p_rs: Recordset buit.';
        
		DBMS_OUTPUT.put_line (v_resultat);				
-- Gravem al LOG
		GESTIO_LOG.INS_LOG(v_dataInici, v_dataFi, v_procediment, v_paramEnt, v_paramSor, v_resultat);
			
END CNS_JUGADORS_BASE;
---------------------------------------------------------------------------------


---------------------------------------------------------------------------------
-- CU01-06: Afegir perfil de Xarxa Social
-- Parmetres d'entrada:
--		* p_xarxaId: Identificador de Xarxa social
--		* p_jugadorId: Identificador del Jugador
--		* p_nomUsuari: Nom d'usuari del Jugador a la Xarxa Social
--		* p_contrasenya: Paraula de pas del Jugador a la Xarxa Social
-- 		* p_dataAlta: Data d'alta del perfil al sistema
-- Parmetres de sortida: 
--		* p_resultat: Resultat del procediment OK/KO
---------------------------------------------------------------------------------
PROCEDURE INS_JUGADORS_XARXES( p_xarxaId IN PFCBD.JUGADORS_XARXES.XARXES_SOCIALS_ID%TYPE, 
							   p_jugadorId IN PFCBD.JUGADORS_XARXES.JUGADORS_ID%TYPE,
							   p_nomUsuari IN PFCBD.JUGADORS_XARXES.NOMUSUARI%TYPE,
							   p_contrasenya IN PFCBD.JUGADORS_XARXES.CONTRASENYA%TYPE,
							   p_dataAlta IN PFCBD.JUGADORS_XARXES.DATAALTA%TYPE,
							   p_resultat OUT VARCHAR)
IS
  v_contrasenya PFCBD.JUGADORS_XARXES.CONTRASENYA%TYPE;

  -- Valors per registrar al LOG	
	v_dataInici PFCBD.LOG.DATAINICI%TYPE;
	v_dataFi PFCBD.LOG.DATAFI%TYPE;
	v_procediment PFCBD.LOG.PROCEDIMENT%TYPE;
	v_paramEnt PFCBD.LOG.PARAMENTRADA%TYPE;
	v_paramSor PFCBD.LOG.PARAMSORTIDA%TYPE;
	v_resultat PFCBD.LOG.RESULTAT%TYPE;
  
BEGIN

-- S'assignen els valors d'entrada
	v_dataInici        := SYSDATE;   
	v_procediment := $$PLSQL_UNIT || '.INS_JUGADORS_XARXES';
	v_paramEnt       := 'p_xarxaId = ' || p_xarxaId 
                      || ', p_jugadorId = ' || p_jugadorId
					  || ', p_nomUsuari = ' || p_nomUsuari
					  || ', p_contrasenya = ' || get_hash(upper(p_nomUsuari), p_contrasenya)
					  || ', p_dataAlta = ' || p_dataAlta;

  if p_contrasenya is not null then
        v_contrasenya:=  get_hash(upper(p_nomUsuari), p_contrasenya);
  end if;
 
   -- S'inserta el nou Perfil		
  INSERT INTO JUGADORS_XARXES(XARXES_SOCIALS_ID, JUGADORS_ID, NOMUSUARI, CONTRASENYA, DATAALTA) 
  VALUES (p_xarxaId, p_jugadorId, upper(p_nomUsuari), v_contrasenya, nvl(p_dataAlta,sysdate));

  
  -- S'omplen els valors de sortida
    p_resultat := 'OK';
    v_dataFi    := SYSDATE;
	v_paramSor	:= 'p_resultat: ' || p_resultat;
	v_resultat     := '00: Perfil donat d''alta correctament';
  
  -- Es grava al LOG
    GESTIO_LOG.INS_LOG(v_dataInici, v_dataFi, v_procediment, v_paramEnt, v_paramSor, v_resultat);	  
  
  EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE) 
                    WHEN -1 THEN
                        -- Registre duplicat
                        v_resultat := '01: Ja s''havia inserit el registre anteriorment.';
                    WHEN -1400 THEN
                        -- Valor nul
                        v_resultat := '02: S''ha intentat inserir un valor NULL' || SUBSTR(SQLERRM,INSTR(SQLERRM,'('));
                    WHEN -02291 THEN
                        v_resultat := '02: Error d''integritat referencial ' || SUBSTR(SQLERRM,INSTR(SQLERRM,'('));
                    ELSE
                        -- Error no controlat
                        v_resultat := '99: ' || SQLCODE || ' - ' || SQLERRM;
                END CASE;            

	-- S'assignem els valors de sortida 
	p_resultat := 'KO';
    v_dataFi    := SYSDATE;
    v_paramSor	:= 'p_resultat: ' || p_resultat;
        
	DBMS_OUTPUT.put_line (v_resultat);				
-- Gravem al LOG
    GESTIO_LOG.INS_LOG(v_dataInici, v_dataFi, v_procediment, v_paramEnt, v_paramSor, v_resultat);	
				
END INS_JUGADORS_XARXES;
---------------------------------------------------------------------------------


---------------------------------------------------------------------------------
-- CU01-07: Actualitzar perfil de Xarxa Social
-- Procediment que permetr actualitzar un perfil d'una xarxa social/Jugador
-- Parmetres d'entrada:
--		* p_Id: Identificador del Perfil
--		* p_xarxaId: Identificador de Xarxa social
--		* p_jugadorId: Identificador del Jugador
--		* p_nomUsuari: Nom d'usuari del Jugador a la Xarxa Social
--		* p_contrasenya: Paraula de pas del Jugador a la Xarxa Social
-- Parmetres de sortida: 
--		* p_resultat: Resultat del procediment OK/KO
---------------------------------------------------------------------------------
PROCEDURE UPD_JUGADORS_XARXES( p_id IN PFCBD.JUGADORS_XARXES.ID%TYPE,
							   p_xarxaId IN PFCBD.JUGADORS_XARXES.XARXES_SOCIALS_ID%TYPE, 
							   p_jugadorId IN PFCBD.JUGADORS_XARXES.JUGADORS_ID%TYPE,
							   p_nomUsuari IN PFCBD.JUGADORS_XARXES.NOMUSUARI%TYPE,
							   p_contrasenya IN PFCBD.JUGADORS_XARXES.CONTRASENYA%TYPE,
							   p_resultat OUT VARCHAR)
IS
 -- Valors per registrar al LOG	
	v_dataInici PFCBD.LOG.DATAINICI%TYPE;
	v_dataFi PFCBD.LOG.DATAFI%TYPE;
	v_procediment PFCBD.LOG.PROCEDIMENT%TYPE;
	v_paramEnt PFCBD.LOG.PARAMENTRADA%TYPE;
	v_paramSor PFCBD.LOG.PARAMSORTIDA%TYPE;
	v_resultat PFCBD.LOG.RESULTAT%TYPE;
	
  v_contrasenya PFCBD.JUGADORS_XARXES.CONTRASENYA%TYPE;
  v_id PFCBD.JUGADORS_XARXES.ID%TYPE;
  v_xarxaid PFCBD.JUGADORS_XARXES.XARXES_SOCIALS_ID%TYPE;
  v_jugadorid PFCBD.JUGADORS_XARXES.JUGADORS_ID%TYPE;
BEGIN

-- S'assignen els valors d'entrada
	v_dataInici        := SYSDATE;   
	v_procediment := $$PLSQL_UNIT || '.UPD_JUGADORS_XARXES';
	v_paramEnt       := 'p_id = ' || p_id 
                      || ', p_xarxaId = ' || p_xarxaId
					  || ', p_jugadorId = ' || p_jugadorId
					  || ', p_nomUsuari = ' || p_nomUsuari
					  || ', p_contrasenya = ' || get_hash(upper(p_nomUsuari), p_contrasenya);
 
  if p_contrasenya is not null then
        v_contrasenya:=  get_hash(upper(p_nomUsuari), p_contrasenya);
  end if;
 
  if p_id is null then
      RAISE_APPLICATION_ERROR(-20003,'');  
  end if;
  
-- Es verifica que el Perfil existeix al sistema
	BEGIN
    IF p_id IS NOT NULL THEN
        SELECT ID into v_id
        FROM JUGADORS_XARXES
        WHERE ID = p_id;
    END IF;
    EXCEPTION
        WHEN OTHERS THEN
             IF (SQLCODE = 100) THEN
                   -- Perfil no trobat
                   RAISE_APPLICATION_ERROR(-20000,'');
             END IF; 
	END;  
		
 
-- Es verifica que la Xarxa Social existeix en el sistema
	BEGIN
    IF p_xarxaId IS NOT NULL THEN
        SELECT ID into v_xarxaid
        FROM XARXES_SOCIALS
        WHERE ID = p_xarxaId;
    END IF;
    EXCEPTION
        WHEN OTHERS THEN
             IF (SQLCODE = 100) THEN
                   -- Xarxa Social no trobada
                   RAISE_APPLICATION_ERROR(-20001,'');
             END IF; 
	END;  
 
-- Es verifica que el Jugador existeix en el sistema
	BEGIN
    IF p_jugadorId IS NOT NULL THEN
        SELECT ID into v_jugadorid
        FROM JUGADORS
        WHERE ID = p_jugadorId;
    END IF;
    EXCEPTION
        WHEN OTHERS THEN
             IF (SQLCODE = 100) THEN
                   -- Jugador no trobat
                   RAISE_APPLICATION_ERROR(-20002,'');
             END IF; 
	END;  
  
 
	-- S'actualitza el Perfil		
	UPDATE JUGADORS_XARXES 
	SET XARXES_SOCIALS_ID = p_xarxaId, JUGADORS_ID = p_jugadorId, NOMUSUARI = upper(p_nomUsuari), CONTRASENYA = v_contrasenya  
	WHERE JUGADORS_XARXES.ID = p_id;
			
			
	-- S'omplen els valors de sortida
    p_resultat := 'OK';
    v_dataFi    := SYSDATE;
	v_paramSor	:= 'p_resultat: ' || p_resultat;
	v_resultat     := '00: Perfil Actualitzat correctament';
      
	-- Es grava al LOG
    GESTIO_LOG.INS_LOG(v_dataInici, v_dataFi, v_procediment, v_paramEnt, v_paramSor, v_resultat);	
  
  EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE) 
                    WHEN -1 THEN
                        -- Registre duplicat
                        v_resultat := '01: Ja s''havia inserit el registre anteriorment.';
                    WHEN -1407 THEN
                        -- Valor nul
                        v_resultat := '02: S''ha intentat inserir un valor NULL' || SUBSTR(SQLERRM,INSTR(SQLERRM,'('));
                    WHEN -20000 THEN
                         v_resultat := '03: Perfil no trobat amb ID = ' || p_id;
                    WHEN -20001 THEN
                         v_resultat := '03: Xarxa Social no trobada amb ID = ' || p_xarxaId;
                    WHEN -20002 THEN
                         v_resultat := '03: Jugador no trobat amb ID = ' || p_jugadorId;
                    WHEN -20003 THEN
                         v_resultat := '03: S''ha d''introduir l''identificador del perfil a actualitzar';
					ELSE
                        -- Error no controlat
                        v_resultat := '99: ' || SQLCODE || ' - ' || SQLERRM;
                END CASE;            

	-- S'assignem els valors de sortida 
	p_resultat := 'KO';
    v_dataFi    := SYSDATE;
    v_paramSor	:= 'p_resultat: ' || p_resultat;
        
	DBMS_OUTPUT.put_line (v_resultat);				
	-- Gravem al LOG
    GESTIO_LOG.INS_LOG(v_dataInici, v_dataFi, v_procediment, v_paramEnt, v_paramSor, v_resultat);	
				
END UPD_JUGADORS_XARXES;
---------------------------------------------------------------------------------


---------------------------------------------------------------------------------
-- CU01-08: Baixa perfil de Xarxa Social
-- Parmetres d'entrada:
--		* p_id: Identificador del Perfil
--		* p_dataBaixa: Data de baixa del perfil
-- Parmetres de sortida: 
--		* p_resultat: Resultat del procediment OK/KO
--
-- Procediment que permetr donar de baixa un perfil. 
-- Si no s'introdueix cap data es donar de baixa el perfil amb data del dia.
---------------------------------------------------------------------------------
PROCEDURE BX_JUGADORS_XARXES( p_id IN PFCBD.JUGADORS_XARXES.ID%TYPE,
							  p_dataBaixa IN PFCBD.JUGADORS_XARXES.DATABAIXA%TYPE,
							  p_resultat OUT VARCHAR)
IS
	v_id PFCBD.JUGADORS_XARXES.ID%TYPE;
	
	-- Valors per registrar al LOG	
	v_dataInici PFCBD.LOG.DATAINICI%TYPE;
	v_dataFi PFCBD.LOG.DATAFI%TYPE;
	v_procediment PFCBD.LOG.PROCEDIMENT%TYPE;
	v_paramEnt PFCBD.LOG.PARAMENTRADA%TYPE;
	v_paramSor PFCBD.LOG.PARAMSORTIDA%TYPE;
	v_resultat PFCBD.LOG.RESULTAT%TYPE;
BEGIN
	
	-- S'assignen els valors d'entrada
	v_dataInici        := SYSDATE;   
	v_procediment := $$PLSQL_UNIT || '.BX_JUGADORS_XARXES';
	v_paramEnt       := 'p_id = ' || p_id 
                      || ', p_dataBaixa = ' || p_dataBaixa;

  if p_id is null then
      RAISE_APPLICATION_ERROR(-20000,'');  
  end if;
  
-- Es verifica que el Perfil existeix al sistema
	BEGIN
    IF p_id IS NOT NULL THEN
        SELECT ID into v_id
        FROM JUGADORS_XARXES
        WHERE ID = p_id;
    END IF;
    EXCEPTION
        WHEN OTHERS THEN
             IF (SQLCODE = 100) THEN
                   -- Perfil no trobat
                   RAISE_APPLICATION_ERROR(-20001,'');
             END IF; 
	END;  
 
	-- S'actualitza el Perfil		
	UPDATE JUGADORS_XARXES 
	SET DATABAIXA = nvl(p_dataBaixa, sysdate)
	WHERE JUGADORS_XARXES.ID = p_id;
			
	-- S'omplen els valors de sortida
    p_resultat := 'OK';
    v_dataFi    := SYSDATE;
	v_paramSor	:= 'p_resultat: ' || p_resultat;
	v_resultat     := '00: Perfil donat de baixa correctament';
      
	-- Es grava al LOG
    GESTIO_LOG.INS_LOG(v_dataInici, v_dataFi, v_procediment, v_paramEnt, v_paramSor, v_resultat);	
	
    EXCEPTION
            WHEN OTHERS THEN
                CASE (SQLCODE) 
                    WHEN -20001 THEN
                         v_resultat := '03: Perfil no trobat amb ID = ' || p_id;
                    WHEN -20000 THEN
                         v_resultat := '03: S''ha d''introduir l''identificador del perfil a donar de baixa';
					ELSE
                        -- Error no controlado
                        v_resultat := '99: ' || SQLCODE || ' - ' || SQLERRM;
                END CASE;            

	-- S'assignem els valors de sortida 
	p_resultat := 'KO';
    v_dataFi    := SYSDATE;
    v_paramSor	:= 'p_resultat: ' || p_resultat;
        
	DBMS_OUTPUT.put_line (v_resultat);				
	-- Gravem al LOG
    GESTIO_LOG.INS_LOG(v_dataInici, v_dataFi, v_procediment, v_paramEnt, v_paramSor, v_resultat);	
				
END BX_JUGADORS_XARXES;
---------------------------------------------------------------------------------


---------------------------------------------------------------------------------
-- CU01-09: Consulta Perfil de Xarxa Social
-- Parmeres d'entrada:
--		* p_id: Identificador del Perfil
--		* p_xarxaId: Identificador de la Xarxa Social
--		* p_JugadorId: Identificador del Jugador
-- Parmetres de sortida: 
--		* p_rs: Recordset amb la informaci
--		* p_resultat: Resultat del procediment OK/KO
--
-- Es permetr realitzar la consulta dels perfils.
-- Si es rep l'identificador del perfil consultat es retornar la seva informaci.
-- Si no es rep identificador del perfil consultat es formar una query dinmica a partir dels parmeres p_xarxaId i p_JugadorId obtinguts, 
-- realitzat la consulta de tota la taula si no hi ha criteri de selecci.
---------------------------------------------------------------------------------
PROCEDURE CNS_JUGADORS_XARXES ( p_rs OUT sys_refcursor, 	
						p_id IN PFCBD.JUGADORS_XARXES.ID%TYPE, 
						p_xarxaId IN PFCBD.JUGADORS_XARXES.XARXES_SOCIALS_ID%TYPE,
						p_JugadorId IN PFCBD.JUGADORS_XARXES.JUGADORS_ID%TYPE,
						p_resultat OUT VARCHAR)
IS
	-- Valors per registrar al LOG	
	v_dataInici PFCBD.LOG.DATAINICI%TYPE;
	v_dataFi PFCBD.LOG.DATAFI%TYPE;
	v_procediment PFCBD.LOG.PROCEDIMENT%TYPE;
	v_paramEnt PFCBD.LOG.PARAMENTRADA%TYPE;
	v_paramSor PFCBD.LOG.PARAMSORTIDA%TYPE;
	v_resultat PFCBD.LOG.RESULTAT%TYPE;
	
	v_cerca VARCHAR(500);
BEGIN

	-- S'assignen els valors d'entrada
	v_dataInici        := SYSDATE;   
	v_procediment := $$PLSQL_UNIT || '.CNS_JUGADORS_XARXES';
	v_paramEnt       := 'p_id = ' || p_id 
                      || ', p_xarxaId = ' || p_xarxaId
					  || ', p_JugadorId = ' || p_JugadorId;

	if p_id is not NULL then
		v_cerca := 'SELECT * FROM JUGADORS_XARXES where id =' || p_id;
	ELSE
 		if p_xarxaId is not NULL then
			v_cerca := 'SELECT * FROM JUGADORS_XARXES where XARXES_SOCIALS_ID = ''' || p_xarxaId || '''';
		end if;
	  
		if p_JugadorId IS NOT NULL THEN
			IF v_cerca IS NULL THEN
				v_cerca := 'SELECT * FROM JUGADORS_XARXES where JUGADORS_ID = ''' || p_JugadorId || '''';
			ELSE
				v_cerca := v_cerca || ' AND (JUGADORS_ID = ''' || p_JugadorId || ''')';
			END IF;
		end if;
	
	END IF;
	
	-- Consulta per extreure les dades d'un Joc
	IF v_cerca IS NOT NULL THEN
			OPEN p_rs FOR v_cerca;
	ELSE

	-- S'extreuen tots els perfils	 
      OPEN p_rs FOR
	  SELECT *
	  FROM JUGADORS_XARXES;
	
	END IF;
			
	-- S'omplen els valors de sortida
    p_resultat := 'OK';
    v_dataFi    := SYSDATE;
	v_paramSor	:= 'p_resultat: ' || p_resultat || ', p_rs: Recordset amb el resultat de la consulta.';
	v_resultat := '00: Consulta realitzada correctament';
      
	-- Es grava al LOG
    GESTIO_LOG.INS_LOG(v_dataInici, v_dataFi, v_procediment, v_paramEnt, v_paramSor, v_resultat);	  
	  
	  
	EXCEPTION
            WHEN OTHERS THEN
				v_resultat := '99: ' || SQLCODE || ' - ' || SQLERRM;
               
  	-- Es genera un recordset buit
       OPEN p_rs FOR
       SELECT * FROM DUAL WHERE DUMMY IS NULL;
				
	-- S'assignem els valors de sortida 
		p_resultat := 'KO';
		v_dataFi    := SYSDATE;
		v_paramSor	:= 'p_resultat: ' || p_resultat || ', p_rs: Recordset amb el resultat de la consulta.';
        
		DBMS_OUTPUT.put_line (v_resultat);				
	-- Gravem al LOG
		GESTIO_LOG.INS_LOG(v_dataInici, v_dataFi, v_procediment, v_paramEnt, v_paramSor, v_resultat);	
				
END CNS_JUGADORS_XARXES;
---------------------------------------------------------------------------------
    
END GESTIO_USUARIS;
/


