---------------------------------------------------------------------------------
-- Alumne: Jessica Villamor 
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO DE VIDEOJOCS
---------------------------------------------------------------------------------


--
-- Ens situem a l'esquema del magatzem de dades
--
ALTER SESSION SET CURRENT_SCHEMA = PFCDW;

-- Taules de dimensions

CREATE TABLE D_JUGADORS (
  IdJugador NUMBER NOT NULL,
  Nom VARCHAR(770) NOT NULL,
  Sexe VARCHAR(1) NOT NULL,
  CONSTRAINT PK_D_JUGADORS PRIMARY KEY(IdJugador)
);


CREATE TABLE D_NIVELLS (
  IdNivell NUMBER NOT NULL,
  Joc VARCHAR(255) NOT NULL,
  Nom VARCHAR(255) NOT NULL,
  CONSTRAINT PK_D_NIVELLS PRIMARY KEY(IdNivell)
);


CREATE TABLE D_TEMPS (
  IdTemps CHAR(8) NOT NULL,
  Dia  CHAR(2) NOT NULL,
  Mes CHAR(2) NOT NULL,
  Anyo CHAR(4) NOT NULL,
  CONSTRAINT PK_D_TEMPS PRIMARY KEY(IdTemps)
);


CREATE TABLE D_XARXESSOCIALS (
  IdXarxa NUMBER NOT NULL,
  Nom VARCHAR(255) NOT NULL,
  CONSTRAINT PK_D_XARXESSOCIALS PRIMARY KEY(IdXarxa)
);


CREATE TABLE D_PRODUCTES (
  IdProducte NUMBER NOT NULL,
  Nom VARCHAR(255) NOT NULL,
  Tipologia VARCHAR(5) NOT NULL,
  Preu FLOAT NOT NULL ,
  CONSTRAINT PK_D_PRODUCTES PRIMARY KEY(IdProducte)
);


CREATE TABLE D_ESTATS (
  IdEstat NUMBER NOT NULL,
  Nom VARCHAR(25) NOT NULL,
  CONSTRAINT PK_D_ESTATS PRIMARY KEY(IdEstat)
);


-- Taules de Fets

CREATE TABLE F_COLLABORACIONS (
   IdXarxa NUMBER NOT NULL,
   IdJugadorSol NUMBER NOT NULL,
   IdJugadorAmi NUMBER NOT NULL,
   IdProducte NUMBER NOT NULL,
   IdTempsInici CHAR(8) NOT NULL,
   IdEstat NUMBER NOT NULL,
   NumRegistrades NUMBER,
   PromigDies Float,
  CONSTRAINT PK_F_COLLABORACIONS PRIMARY KEY(IdXarxa, IdJugadorSol, IdJugadorAmi, IdProducte, IdTempsInici, IdEstat),
  CONSTRAINT FK1_COLLABORACIONS_XARXES FOREIGN KEY(IdXarxa) REFERENCES D_XARXESSOCIALS(IdXarxa),
  CONSTRAINT FK2_COLLABORACIONS_JUGSOL FOREIGN KEY(IdJugadorSol) REFERENCES D_JUGADORS(IdJugador),
  CONSTRAINT FK3_COLLABORACIONS_JUGAMI FOREIGN KEY(IdJugadorAmi) REFERENCES D_JUGADORS(IdJugador),
  CONSTRAINT FK4_COLLABORACIONS_PRODUCTES FOREIGN KEY(IdProducte) REFERENCES D_PRODUCTES(IdProducte),
  CONSTRAINT FK5_COLLABORACIONS_TEMPSINI FOREIGN KEY(IdTempsInici) REFERENCES D_TEMPS(IdTemps),
  CONSTRAINT FK7_COLLABORACIONS_ESTAT FOREIGN KEY(IdEstat) REFERENCES D_ESTATS(IdEstat)
);

CREATE TABLE F_COMPRES (
   IdProducte NUMBER NOT NULL,
   IdTemps CHAR(8) NOT NULL,
   IdNivell NUMBER NOT NULL,
   IdJugador NUMBER NOT NULL,
   NumcompRegistrades NUMBER,
   Import FLOAT,
  CONSTRAINT PK_F_COMPRES PRIMARY KEY(IdProducte, IdTemps, IdNivell, IdJugador),
  CONSTRAINT FK1_COMPRES_PRODUCTES FOREIGN KEY(IdProducte) REFERENCES D_PRODUCTES(IdProducte),
  CONSTRAINT FK2_COMPRES_TEMPS FOREIGN KEY(IdTemps) REFERENCES D_TEMPS(IdTemps),
  CONSTRAINT FK3_COMPRES_NIVELLS FOREIGN KEY(IdNivell) REFERENCES D_NIVELLS(IdNivell),
  CONSTRAINT FK4_COMPRES_JUGADOR FOREIGN KEY(IdJugador) REFERENCES D_JUGADORS(IdJugador)
);


CREATE TABLE F_PARTIDES (
   IdTemps CHAR(8) NOT NULL,
   IdNivell NUMBER NOT NULL,
   IdJugador NUMBER NOT NULL,
   NumPartidesReg NUMBER,
   NumAmbNivellSuperat NUMBER,
   NumVidesUtilitzades NUMBER,
   NumVidesExtra NUMBER,
   NumVidesCedides NUMBER,
   NumAjudes NUMBER,
  CONSTRAINT PK_F_PARTIDES PRIMARY KEY(IdTemps, IdNivell, IdJugador),
  CONSTRAINT FK1_PARTIDES_TEMPS FOREIGN KEY(IdTemps) REFERENCES D_TEMPS(IdTemps),
  CONSTRAINT FK2_PARTIDES_NIVELLS FOREIGN KEY(IdNivell) REFERENCES D_NIVELLS(IdNivell),
  CONSTRAINT FK3_PARTIDES_JUGADOR FOREIGN KEY(IdJugador) REFERENCES D_JUGADORS(IdJugador)
);


