---------------------------------------------------------------------------------
-- Alumne: Jessica Villamor 
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO DE VIDEOJOCS
---------------------------------------------------------------------------------

-- Procediment Test: Collaboraci

--
-- Ens situem a l'esquema de la base de dades de Gesti de Videojocs
--
ALTER SESSION SET CURRENT_SCHEMA = PFCBD;

Create or replace
PACKAGE PFCBD.TEST_G_COLLABORACIO AS
		
		PROCEDURE TEST_COLLABORACIO;
				
END TEST_G_COLLABORACIO;
/


CREATE OR REPLACE PACKAGE BODY PFCBD.TEST_G_COLLABORACIO AS

---------------------------------------------------------------------------------
-- Test dels procediments CU04: Collaboraci
---------------------------------------------------------------------------------
 
    PROCEDURE TEST_COLLABORACIO
    IS
		v_resultat PFCBD.LOG.RESULTAT%TYPE;
		v_rs sys_refcursor;
		
		v_Collaboracio COLLABORACIONS%ROWTYPE;
		v_Producte PRODUCTES%ROWTYPE;
		v_perfil JUGADORS_XARXES%ROWTYPE;
		
		v_JugadorAId number;
		v_JugadorBId number;
	
		v_PartidaId number;
		v_CollaboracioError number;
		
		
		v_perfilA JUGADORS_XARXES%ROWTYPE;
		v_perfilB JUGADORS_XARXES%ROWTYPE;
		v_perfilerror JUGADORS_XARXES%ROWTYPE;
	
		v_CODPROV  number;
		v_CODPAIS  varchar(2);
		v_CODPOB  number;
		v_Nom Varchar(255);
		v_PrimerCog  Varchar(255);
		v_SegonCog VARCHAR(255);
		v_Sexe VARCHAR(1);
		v_Mail VARCHAR(255);
		
		
		
    BEGIN

		-- PREPARACIO DE DADES
		-- S'insereix el jugador sollicitant
		GESTIO_USUARIS.INS_JUGADORS(null, 'ES', null, null, 'JUGADOR_A', 'PJUGA', 'JUGADOR_A', 'COG1', 'COG2', 'F', NULL, v_resultat);
		-- S'insereix el jugador amic
		GESTIO_USUARIS.INS_JUGADORS(null, 'ES', null, null, 'JUGADOR_B', 'PJUGB', 'JUGADOR_B', 'COG1', 'COG2', 'F', NULL, v_resultat);
		-- Consulta correcta, es vol consultar l'identificador del jugador_a creat
		GESTIO_USUARIS.CNS_JUGADORS_BASE (v_rs, '', 'JUGADOR_A', v_resultat);
		IF (v_rs IS NOT NULL) THEN
		    FETCH v_rs INTO v_JugadorAId, v_CODPROV, v_CODPAIS, v_CODPOB, v_Nom, v_PrimerCog, v_SegonCog, v_Sexe, v_Mail;
			CLOSE v_rs;
		END IF;
		-- Consulta correcta, es vol consultar l'identificador del jugador_a creat
		GESTIO_USUARIS.CNS_JUGADORS_BASE (v_rs, '', 'JUGADOR_B', v_resultat);
		IF (v_rs IS NOT NULL) THEN
		    FETCH v_rs INTO v_JugadorBId, v_CODPROV, v_CODPAIS, v_CODPOB, v_Nom, v_PrimerCog, v_SegonCog, v_Sexe, v_Mail;
			CLOSE v_rs;
		END IF;
		-- Creaci dels perfils de la xarxa social 1
		GESTIO_USUARIS.INS_JUGADORS_XARXES(1, v_JugadorAId, 'jugadorA1', 'paraulapas', null,  v_resultat);					  
		GESTIO_USUARIS.INS_JUGADORS_XARXES(1, v_JugadorBId, 'jugadorB1', 'paraulapas', null,  v_resultat);					  
		-- Creaci dels perfils de la xarxa social 2 per forar error posterior
		GESTIO_USUARIS.INS_JUGADORS_XARXES(2, v_JugadorBId, 'jugadorB1', 'paraulapas', null,  v_resultat);					  
		-- Consulta dels perfils creats
		-- PROCEDURE CNS_JUGADORS_XARXES ( p_rs OUT sys_refcursor, p_id IN PFCBD.JUGADORS_XARXES.ID%TYPE, p_xarxaId IN PFCBD.JUGADORS_XARXES.XARXES_SOCIALS_ID%TYPE, p_JugadorId IN PFCBD.JUGADORS_XARXES.JUGADORS_ID%TYPE, p_resultat OUT VARCHAR);
		GESTIO_USUARIS.CNS_JUGADORS_XARXES (v_rs, null, 1, v_JugadorAId, v_resultat);
		IF (v_rs IS NOT NULL) THEN
		    FETCH v_rs INTO v_perfilA;
		END IF;
		
		GESTIO_USUARIS.CNS_JUGADORS_XARXES (v_rs, null, 1, v_JugadorBId, v_resultat);
		IF (v_rs IS NOT NULL) THEN
		    FETCH v_rs INTO v_perfilB;
		END IF;
		
		GESTIO_USUARIS.CNS_JUGADORS_XARXES (v_rs, null, 2, v_JugadorBId, v_resultat);
		IF (v_rs IS NOT NULL) THEN
		    FETCH v_rs INTO v_perfilerror;
		END IF;
		
			
		-- Test INS_COLLABORACIONS_SOL
		-- PROCEDURE INS_COLLABORACIONS_SOL ( p_perfilSolId IN PFCBD.COLLABORACIONS.JUGXAR_SOL_ID%TYPE, p_perfilAmiId IN PFCBD.COLLABORACIONS.JUGXAR_AMIC_ID%TYPE, p_producteId IN PFCBD.PRODUCTES.ID%TYPE, p_resultat OUT VARCHAR);
		-- Sollicitut Correcta
		COLLABORACIO.INS_COLLABORACIONS_SOL(v_perfilA.ID, v_perfilB.ID, 1, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
				
		-- Test CNS_COLLABORACIONS_JUGXAR
		-- PROCEDURE CNS_COLLABORACIONS_JUGXAR ( p_rs OUT	sys_refcursor, p_xarxaId IN PFCBD.JUGADORS_XARXES.XARXES_SOCIALS_ID%TYPE, p_jugadorId IN PFCBD.JUGADORS_XARXES.JUGADORS_ID%TYPE, p_baixes IN VARCHAR, p_resultat OUT VARCHAR);
		-- Consulta Correcta
		COLLABORACIO.CNS_COLLABORACIONS_JUGXAR(v_rs, 1, v_JugadorAId, null, v_resultat);
		FETCH v_rs INTO  v_perfil;
		IF v_rs%FOUND  THEN
			DBMS_OUTPUT.put_line ('OK: Consulta amb resultats.');
		ELSE
			DBMS_OUTPUT.put_line ('KO: Consulta sense resultats.');
		END IF;
		
		-- Error parmetres d'entrada obligatoris
		COLLABORACIO.CNS_COLLABORACIONS_JUGXAR(v_rs, null, v_JugadorAId, null, v_resultat);
		COLLABORACIO.CNS_COLLABORACIONS_JUGXAR(v_rs, 1, null, null, v_resultat);
		 		
		-- Error Xarxa Social no trobada
		COLLABORACIO.CNS_COLLABORACIONS_JUGXAR(v_rs, 99, v_JugadorAId, null, v_resultat);
		
		-- Error Jugador no trobat
		COLLABORACIO.CNS_COLLABORACIONS_JUGXAR(v_rs, 1, 99, null, v_resultat);
         
        
		-- CNS_COLLABORACIONS_LIST
		-- PROCEDURE CNS_COLLABORACIONS_LIST (p_rs IN OUT sys_refcursor, p_jocId IN PFCBD.JOCS.ID%TYPE, p_collaboracioId IN PFCBD.COLLABORACIONS.ID%TYPE, p_perfilsolId IN PFCBD.JUGADORS_XARXES.ID%TYPE, p_actives IN varchar, p_resultat OUT VARCHAR);
		-- Consulta correcta
		COLLABORACIO.CNS_COLLABORACIONS_LIST(v_rs, 1, null, v_perfilA.ID, 'X', v_resultat );
		FETCH v_rs INTO v_Collaboracio;
		IF v_rs%FOUND  THEN
			DBMS_OUTPUT.put_line ('OK: Consulta amb resultats.');
		ELSE
			DBMS_OUTPUT.put_line ('KO: Consulta sense resultats.');
		END IF;
		
		-- Error parmetres obligatoris
		COLLABORACIO.CNS_COLLABORACIONS_LIST(v_rs, 1, null, null, 'X', v_resultat );
		
		-- Error collaboraci inexistent
		COLLABORACIO.CNS_COLLABORACIONS_LIST(v_rs, 1, 99, v_perfilA.ID, 'X', v_resultat );
				
		-- Error Perfil inexistent
		COLLABORACIO.CNS_COLLABORACIONS_LIST(v_rs, 1, v_Collaboracio.ID, 99, 'X', v_resultat );
		
		-- Error Joc inexistent
		COLLABORACIO.CNS_COLLABORACIONS_LIST(v_rs, 99, v_Collaboracio.ID, v_perfilA.ID, 'X', v_resultat );
		
		
		-- Test INS_COLLABORACIONS_SOL, UPD_COLLABORACIONS_ACE
		-- PROCEDURE UPD_COLLABORACIONS_ACE (p_collaboracioId IN PFCBD.COLLABORACIONS.ID%TYPE, p_resultat OUT VARCHAR);
		-- PROCEDURE INS_COLLABORACIONS_SOL ( p_perfilSolId IN PFCBD.COLLABORACIONS.JUGXAR_SOL_ID%TYPE, p_perfilAmiId IN PFCBD.COLLABORACIONS.JUGXAR_AMIC_ID%TYPE, p_producteId IN PFCBD.PRODUCTES.ID%TYPE, p_resultat OUT VARCHAR);
        
		-- Acceptar collaboraci correctament
        COLLABORACIO.UPD_COLLABORACIONS_ACE(v_Collaboracio.ID, v_resultat);   
		DBMS_OUTPUT.put_line (v_resultat); 		
		
		-- Error: Parmetres obligatoris
		COLLABORACIO.INS_COLLABORACIONS_SOL(null, v_perfilB.ID, 1, v_resultat);
		COLLABORACIO.INS_COLLABORACIONS_SOL(v_perfilA.ID, null, 1, v_resultat);
		COLLABORACIO.INS_COLLABORACIONS_SOL(v_perfilA.ID, v_perfilB.ID, null, v_resultat);
		
		-- Error: Perfils no trobats
		COLLABORACIO.INS_COLLABORACIONS_SOL(9999, v_perfilB.ID, 1, v_resultat);
		COLLABORACIO.INS_COLLABORACIONS_SOL(v_perfilA.ID, 9999, 1, v_resultat);

		-- Error: Producte no trobat
		COLLABORACIO.INS_COLLABORACIONS_SOL(v_perfilA.ID, v_perfilB.ID, 99, v_resultat);
		
		-- Error: Collaboraci sollicitada de diferent xarxa social
		COLLABORACIO.INS_COLLABORACIONS_SOL(v_perfilA.ID, v_perfilerror.ID, 1, v_resultat);
			
		-- Error parmetres d'entrada obligatoris
		COLLABORACIO.UPD_COLLABORACIONS_ACE(null, v_resultat);   
		
		-- Error Collaboraci no vigent
		COLLABORACIO.UPD_COLLABORACIONS_ACE(v_Collaboracio.ID, v_resultat);   

		-- S'inicia la partida del jugador sollicitant en el joc 1 per consumir les vides, i no permetre acceptar la collaboraci
		-- Es preparan les dades per a que el jugador B no pugui collaborar perque no tindr vides disponibles
		-- S'inicia la partida del jugador B i es consumeixen 5 vides.
		COLLABORACIO.INS_COLLABORACIONS_SOL(v_perfilA.ID, v_perfilB.ID, 1, v_resultat);
		COLLABORACIO.CNS_COLLABORACIONS_LIST(v_rs, 1, null, v_perfilA.ID, 'X', v_resultat );
		FETCH v_rs INTO v_Collaboracio;
		GESTIO_JOCS.REG_JUGADOR_NIVELLS(v_rs, v_JugadorBId, 1, v_resultat);
		GESTIO_JOCS.REG_PARTIDES_INICIAR(v_PartidaId, v_JugadorBId, 1, null, 1, null, v_resultat);	
		GESTIO_JOCS.UPD_PARTIDA_CNSVIDA(v_PartidaId, v_resultat);
		GESTIO_JOCS.UPD_PARTIDA_CNSVIDA(v_PartidaId, v_resultat);
		GESTIO_JOCS.UPD_PARTIDA_CNSVIDA(v_PartidaId, v_resultat);
		GESTIO_JOCS.UPD_PARTIDA_CNSVIDA(v_PartidaId, v_resultat);
		GESTIO_JOCS.UPD_PARTIDA_CNSVIDA(v_PartidaId, v_resultat);
				
		-- Error: El jugador amic no t vides disponibles
        COLLABORACIO.UPD_COLLABORACIONS_ACE(v_Collaboracio.ID, v_resultat);   
			
		-- Sollicitud de collaboraci per forar error posterior
		DM_PRODUCTES.INS_PRODUCTES(1, 'Producte ZZ', 'AJ', 0, null, v_resultat);
		
		-- Es consulta el producte a actualitzar
		DM_PRODUCTES.CNS_PRODUCTES(v_rs, null, 1, 'Producte ZZ', null, null, v_resultat);
		
		-- Recuperaci de les dades del producte
		IF (v_rs IS NOT NULL) THEN
			FETCH v_rs INTO v_Producte;
			CLOSE v_rs;
		END IF;
		
		-- S'inicia la collaboraci per demanar el producte que no t l'usuari B.
		COLLABORACIO.INS_COLLABORACIONS_SOL(v_perfilA.ID, v_perfilB.ID, v_Producte.ID, v_resultat);
		
		-- Consulta de collaboraci
		COLLABORACIO.CNS_COLLABORACIONS_LIST(v_rs, 1, null, v_perfilA.ID, 'X', v_resultat );
		
		LOOP
			  FETCH v_rs INTO v_Collaboracio;
			  EXIT WHEN v_rs%NOTFOUND;
					IF v_Collaboracio.PRODUCTES_ID = v_Producte.ID THEN
						v_CollaboracioError := v_Collaboracio.ID;
					END IF;
		END LOOP;
			
			
		-- Error: L'ajuda no es activa en el jugador amic
        COLLABORACIO.UPD_COLLABORACIONS_ACE(v_CollaboracioError, v_resultat);   
		
			
 		-- Test UPD_COLLABORACIONS_REF
		-- PROCEDURE UPD_COLLABORACIONS_REF (p_collaboracioId IN PFCBD.COLLABORACIONS.ID%TYPE, p_resultat OUT VARCHAR);
		
		-- Preparaci de dades
		COLLABORACIO.CNS_COLLABORACIONS_LIST(v_rs, 1, null, v_perfilA.ID, 'X', v_resultat );
		FETCH v_rs INTO v_Collaboracio;
		
		-- Refusar collaboraci correctament
		COLLABORACIO.UPD_COLLABORACIONS_REF(v_Collaboracio.ID, v_resultat);
		DBMS_OUTPUT.put_line(v_resultat);
			
		-- Error: collaboraci ja no vigent
		COLLABORACIO.UPD_COLLABORACIONS_REF(v_Collaboracio.ID, v_resultat);
		
		-- Error parmetres obligatoris
		COLLABORACIO.UPD_COLLABORACIONS_REF(null, v_resultat);
				

		-- Test UPD_COLLABORACIONS_CAN
		-- PROCEDURE UPD_COLLABORACIONS_CAN (p_collaboracioId IN PFCBD.COLLABORACIONS.ID%TYPE, p_resultat OUT VARCHAR);
		
		-- Preparaci de dades
		COLLABORACIO.CNS_COLLABORACIONS_LIST(v_rs, 1, null, v_perfilA.ID, 'X', v_resultat );
		FETCH v_rs INTO v_Collaboracio;
			
		-- Cancellar collaboraci correctament
		COLLABORACIO.UPD_COLLABORACIONS_CAN(v_Collaboracio.ID, v_resultat);
		DBMS_OUTPUT.put_line(v_resultat);
			
		-- Error: Collaboraci ja no vigent
		COLLABORACIO.UPD_COLLABORACIONS_CAN(v_Collaboracio.ID, v_resultat);
		
		-- Error parmetres obligatoris
		COLLABORACIO.UPD_COLLABORACIONS_CAN(null, v_resultat); 
		
		
	ROLLBACK;

END TEST_COLLABORACIO;


END TEST_G_COLLABORACIO;


/
