---------------------------------------------------------------------------------
-- Alumne: Jessica Villamor 
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO DE VIDEOJOCS
---------------------------------------------------------------------------------

-- Procediment Test: Gesti d'Assignaci Navegadors a Joc

--
-- Ens situem a l'esquema de la base de dades de Gesti de Videojocs
--
ALTER SESSION SET CURRENT_SCHEMA = PFCBD;

Create or replace
PACKAGE PFCBD.TEST_G_NAVEG_JOCS AS
		
		PROCEDURE TEST_NAVEG_JOCS;
		
	
END TEST_G_NAVEG_JOCS;
/


CREATE OR REPLACE PACKAGE BODY PFCBD.TEST_G_NAVEG_JOCS AS
 
    PROCEDURE TEST_NAVEG_JOCS
    IS
		v_resultat PFCBD.LOG.RESULTAT%TYPE;
		v_rs sys_refcursor;
		v_record JOC_NAVEGADORS%ROWTYPE;
		v_recJoc JOCS%ROWTYPE;

    BEGIN

		-- Test INS_JOC_NAVEGADORS
		-- PROCEDURE INS_JOC_NAVEGADORS( p_joc_id IN PFCBD.JOC_NAVEGADORS.JOCS_ID%TYPE, p_nav_id IN PFCBD.JOC_NAVEGADORS.NAVEGADORS_ID%TYPE, p_resultat OUT VARCHAR);

		-- S'insereix un Joc per testeig
		DM_JOCS.INS_JOCS('Joc A', 0,  v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- Es consulta el joc creat per testejar l'assignaci
		DM_JOCS.CNS_JOCS (v_rs, '', 'Joc A', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- Associaci correcta
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_recJoc;
			  EXIT WHEN v_rs%NOTFOUND;
				 --	Associaci correcta
				 NAVEG_JOCS.INS_JOC_NAVEGADORS ( v_recJoc.ID, 1, v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;

		-- Error Assignaci duplicada
		NAVEG_JOCS.INS_JOC_NAVEGADORS ( v_recJoc.ID, 1, v_resultat);
		  
		-- Error valors nulls
		NAVEG_JOCS.INS_JOC_NAVEGADORS ( null, 1, v_resultat);
		NAVEG_JOCS.INS_JOC_NAVEGADORS ( v_recJoc.ID, null, v_resultat);
 
 		-- Error Joc no trobat
		NAVEG_JOCS.INS_JOC_NAVEGADORS ( 99, 1, v_resultat);
		
		-- Error Navegador no trobat
		NAVEG_JOCS.INS_JOC_NAVEGADORS ( v_recJoc.ID, 99, v_resultat);
				
					
								
		-- Test CNS_JOC_NAVEGADORS
		-- PROCEDURE CNS_JOC_NAVEGADORS(p_rs IN OUT sys_refcursor, p_joc_id IN PFCBD.JOC_NAVEGADORS.JOCS_ID%TYPE, p_resultat OUT VARCHAR);
						
		-- Error: Consulta amb un codi de joc inexistent
		NAVEG_JOCS.CNS_JOC_NAVEGADORS (v_rs, 99, v_resultat);
		
		-- Error: Consulta amb identificador de joc buit
		NAVEG_JOCS.CNS_JOC_NAVEGADORS (v_rs, null, v_resultat);
	
		-- Consulta Correcta
		NAVEG_JOCS.CNS_JOC_NAVEGADORS (v_rs, v_recJoc.ID, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
			

		-- Test DEL_JOC_NAVEGADORS
		-- PROCEDURE DEL_JOC_NAVEGADORS( p_joc_id IN PFCBD.JOC_NAVEGADORS.JOCS_ID%TYPE, p_nav_id IN PFCBD.JOC_NAVEGADORS.NAVEGADORS_ID%TYPE, p_resultat OUT VARCHAR);
		
		-- Desassignaci correcta
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_record;
			  EXIT WHEN v_rs%NOTFOUND;
				 -- Desassignaci correcta
				 NAVEG_JOCS.DEL_JOC_NAVEGADORS (v_recJoc.ID, v_record.NAVEGADORS_ID, v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;
  
 		-- Error Desassignaci: Joc no trobat
		NAVEG_JOCS.DEL_JOC_NAVEGADORS (99, v_record.NAVEGADORS_ID, v_resultat);
		
 		-- Error Desassignaci: Navegador no trobat
		NAVEG_JOCS.DEL_JOC_NAVEGADORS (v_recJoc.ID, 99, v_resultat);

 		-- Error Desassignaci: Valors buits
		NAVEG_JOCS.DEL_JOC_NAVEGADORS (null, v_record.NAVEGADORS_ID, v_resultat);
		NAVEG_JOCS.DEL_JOC_NAVEGADORS (v_recJoc.ID, null, v_resultat);
		
		-- Error Desassignaci: registre no trobat
		NAVEG_JOCS.DEL_JOC_NAVEGADORS (v_recJoc.ID, v_record.NAVEGADORS_ID, v_resultat);
		
		-- Esborrat del joc creat pel testeig
		DM_JOCS.DEL_JOCS ( v_recJoc.ID, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
 
END TEST_NAVEG_JOCS;


END TEST_G_NAVEG_JOCS;


/
