---------------------------------------------------------------------------------
-- Alumne: Jessica Villamor 
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO DE VIDEOJOCS
---------------------------------------------------------------------------------

-- Procediment Test: Gesti d'assignaci Plataformes-Jocs

--
-- Ens situem a l'esquema de la base de dades de Gesti de Videojocs
--
ALTER SESSION SET CURRENT_SCHEMA = PFCBD;

Create or replace
PACKAGE PFCBD.TEST_G_PLATAF_JOCS AS
		
		PROCEDURE TEST_PLATAF_JOCS;
		
	
END TEST_G_PLATAF_JOCS;
/


CREATE OR REPLACE PACKAGE BODY PFCBD.TEST_G_PLATAF_JOCS AS
 
    PROCEDURE TEST_PLATAF_JOCS
    IS
		v_resultat PFCBD.LOG.RESULTAT%TYPE;
		v_rs sys_refcursor;
		v_record PLATAFORMES_JOC%ROWTYPE;
		v_recJoc JOCS%ROWTYPE;

    BEGIN

		-- Test INS_PLATAFORMES_JOC
		-- PROCEDURE INS_PLATAFORMES_JOC( p_joc_id IN PFCBD.PLATAFORMES_JOC.JOCS_ID%TYPE, p_plat_id IN PFCBD.PLATAFORMES_JOC.PLATAFORMES_ID%TYPE, p_resultat OUT VARCHAR);

		-- S'insereix un Joc per testeig
		DM_JOCS.INS_JOCS('Joc A', 0,  v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- Es consulta el joc creat per testejar l'assignaci
		DM_JOCS.CNS_JOCS (v_rs, '', 'Joc A', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- Associaci correcta
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_recJoc;
			  EXIT WHEN v_rs%NOTFOUND;
				 --	Associaci correcta
				 PLATAF_JOCS.INS_PLATAFORMES_JOC ( v_recJoc.ID, 1, v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;

		-- Error Associaci duplicada
		PLATAF_JOCS.INS_PLATAFORMES_JOC ( v_recJoc.ID, 1, v_resultat);
		  
		-- Error valors nulls
		PLATAF_JOCS.INS_PLATAFORMES_JOC ( null, 1, v_resultat);
		PLATAF_JOCS.INS_PLATAFORMES_JOC ( v_recJoc.ID, null, v_resultat);
 
 		-- Error Joc no trobat
		PLATAF_JOCS.INS_PLATAFORMES_JOC ( 99, 1, v_resultat);
		
		-- Error Plataforma no trobada
		PLATAF_JOCS.INS_PLATAFORMES_JOC ( v_recJoc.ID, 99, v_resultat);
				
					
								
		-- Test CNS_PLATAFORMES_JOC
		-- PROCEDURE CNS_PLATAFORMES_JOC(p_rs IN OUT sys_refcursor, p_joc_id IN PFCBD.PLATAFORMES_JOC.JOCS_ID%TYPE, p_resultat OUT VARCHAR);
						
		-- Error: Consulta amb un codi de joc inexistent
		PLATAF_JOCS.CNS_PLATAFORMES_JOC (v_rs, 99, v_resultat);
		
		-- Error: Consulta amb identificador de joc buit
		PLATAF_JOCS.CNS_PLATAFORMES_JOC (v_rs, null, v_resultat);

	
		-- Consulta Correcta
		PLATAF_JOCS.CNS_PLATAFORMES_JOC (v_rs, v_recJoc.ID, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
			

		-- Test DEL_PLATAFORMES_JOC
		-- PROCEDURE DEL_PLATAFORMES_JOC( p_joc_id IN PFCBD.PLATAFORMES_JOC.JOCS_ID%TYPE, p_plat_id IN PFCBD.PLATAFORMES_JOC.PLATAFORMES_ID%TYPE, p_resultat OUT VARCHAR);							
		
		-- Desassignaci correcta
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_record;
			  EXIT WHEN v_rs%NOTFOUND;
				 -- Desassignaci correcta
				 PLATAF_JOCS.DEL_PLATAFORMES_JOC (v_recJoc.ID, v_record.PLATAFORMES_ID, v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;
 
 
 		-- Error Desassignaci: Joc no trobat
		PLATAF_JOCS.DEL_PLATAFORMES_JOC (99, v_record.PLATAFORMES_ID, v_resultat);
		
 		-- Error Desassignaci: Plataforma no trobada
		PLATAF_JOCS.DEL_PLATAFORMES_JOC (v_recJoc.ID, 99, v_resultat);

 		-- Error Desassignaci: Valors buits
		PLATAF_JOCS.DEL_PLATAFORMES_JOC (null, v_record.PLATAFORMES_ID, v_resultat);
		PLATAF_JOCS.DEL_PLATAFORMES_JOC (v_recJoc.ID, null, v_resultat);
		
		-- Error Desassignaci: registre no trobat
		PLATAF_JOCS.DEL_PLATAFORMES_JOC (v_recJoc.ID, v_record.PLATAFORMES_ID, v_resultat);
		
		-- Esborrat del joc creat pel testeig
		DM_JOCS.DEL_JOCS ( v_recJoc.ID, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
 
END TEST_PLATAF_JOCS;


END TEST_G_PLATAF_JOCS;


/
