---------------------------------------------------------------------------------
-- Alumne: Jessica Villamor 
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO DE VIDEOJOCS
---------------------------------------------------------------------------------

-- Procediment Test: Gesti de Compres

--
-- Ens situem a l'esquema de la base de dades de Gesti de Videojocs
--
ALTER SESSION SET CURRENT_SCHEMA = PFCBD;

Create or replace
PACKAGE PFCBD.TEST_G_GESTIO_COMPRES AS
		
		PROCEDURE TEST_GESTIO_COMPRES;
		
	
END TEST_G_GESTIO_COMPRES;
/


CREATE OR REPLACE PACKAGE BODY PFCBD.TEST_G_GESTIO_COMPRES AS
 
    PROCEDURE TEST_GESTIO_COMPRES
    IS
		v_resultat PFCBD.LOG.RESULTAT%TYPE;
		v_rs sys_refcursor;
		v_recordset COMPRES%ROWTYPE;
	
		v_Id number;
		v_JugadorId number;
		v_PartidaId number;
		v_JocId number;
		v_CODPROV  number;
		v_CODPAIS  varchar(2);
		v_CODPOB  number;
		v_Nom Varchar(255);
		v_PrimerCog  Varchar(255);
		v_SegonCog VARCHAR(255);
		v_Sexe VARCHAR(1);
		v_Mail VARCHAR(255);
		
		
    BEGIN

		-- Preparaci de dades per a les proves
		-- S'insereix un jugador
		GESTIO_USUARIS.INS_JUGADORS(null, 'ES', null, null, 'JUGADOR_A', 'PJUGA', 'JUGADOR_A', 'COG1', 'COG2', 'F', NULL, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
				
		-- Consulta correcta, es vol consultar l'identificador del jugador_a creat
		GESTIO_USUARIS.CNS_JUGADORS_BASE (v_rs, '', 'JUGADOR_A', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		IF (v_rs IS NOT NULL) THEN
		    FETCH v_rs INTO v_JugadorId, v_CODPROV, v_CODPAIS, v_CODPOB, v_Nom, v_PrimerCog, v_SegonCog, v_Sexe, v_Mail;
			CLOSE v_rs;
		END IF;
			
		
		-- S'inicia la partida del jugador en el joc 1
		GESTIO_JOCS.REG_JUGADOR_NIVELLS(v_rs, v_JugadorId, 1, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		GESTIO_JOCS.REG_PARTIDES_INICIAR(v_PartidaId, v_JugadorId, 1, null, 1, null, v_resultat);	
		DBMS_OUTPUT.put_line (v_resultat);
		
		
		-- Test INS_AJUDES_COMPRES
		-- PROCEDURE INS_AJUDES_COMPRES ( p_jugadorId IN PFCBD.AJUDES_NIVELL.NIVJUG_JUGADORS_ID%TYPE, p_nivellId IN PFCBD.AJUDES_NIVELL.NIVJUG_NIVELLS_ID%TYPE, p_producteId IN PFCBD.AJUDES_NIVELL.PRODUCTES_ID%TYPE, p_resultat OUT VARCHAR);
		
		-- Es registra la compra d'una ajuda correctament (Producte Id 2 Ajuda)
		GESTIO_COMPRES.INS_AJUDES_COMPRES(v_JugadorId, 1, 2, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- Error: El producte especificat no s del tipus ajuda (Producte Id 1 Vida Extra)
		GESTIO_COMPRES.INS_AJUDES_COMPRES(v_JugadorId, 1, 1, v_resultat);
		
		-- Error, parmetres d'entrada obligatoris
		GESTIO_COMPRES.INS_AJUDES_COMPRES(null, 1, 2, v_resultat);
		GESTIO_COMPRES.INS_AJUDES_COMPRES(v_JugadorId, null, 1, v_resultat);
		GESTIO_COMPRES.INS_AJUDES_COMPRES(v_JugadorId, 1, null, v_resultat);
		
		-- Error, nivell no registrat
		GESTIO_COMPRES.INS_AJUDES_COMPRES(v_JugadorId, 2, 2, v_resultat);
		
		-- Error, producte no disponible
		GESTIO_COMPRES.INS_AJUDES_COMPRES(v_JugadorId, 1, 3, v_resultat);
	
    
		-- Test INS_VIDES_COMPRES
		--	PROCEDURE INS_VIDES_COMPRES ( p_jugadorId IN PFCBD.AJUDES_NIVELL.NIVJUG_JUGADORS_ID%TYPE, p_nivellId IN PFCBD.AJUDES_NIVELL.NIVJUG_NIVELLS_ID%TYPE, p_producteId IN PFCBD.PRODUCTES.ID%TYPE, p_resultat OUT VARCHAR);
		
		-- Es registra la compra d'una vida correctament (Producte Id 1 Vida Extra)
		GESTIO_COMPRES.INS_VIDES_COMPRES(v_JugadorId, 1, 1, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- Error: El producte especificat no s del tipus vida (Producte Id 2 Ajuda)
		GESTIO_COMPRES.INS_VIDES_COMPRES(v_JugadorId, 1, 2, v_resultat);
		
		-- Error, parmetres d'entrada obligatoris
		GESTIO_COMPRES.INS_VIDES_COMPRES(null, 1, 1, v_resultat);
		GESTIO_COMPRES.INS_VIDES_COMPRES(v_JugadorId, null, 1, v_resultat);
		GESTIO_COMPRES.INS_VIDES_COMPRES(v_JugadorId, 1, null, v_resultat);
		
		-- Error, nivell no registrat
		GESTIO_COMPRES.INS_VIDES_COMPRES(v_JugadorId, 2, 1, v_resultat);
		
		-- Error, producte no disponible
		GESTIO_COMPRES.INS_VIDES_COMPRES(v_JugadorId, 1, 5, v_resultat);
		
		
		-- Test CNS_COMPRES
		-- PROCEDURE CNS_COMPRES ( p_rs IN OUT	sys_refcursor, p_jocId IN PFCBD.JOCS.ID%TYPE,  p_jugadorId IN PFCBD.AJUDES_NIVELL.NIVJUG_JUGADORS_ID%TYPE, p_resultat OUT VARCHAR);
		
		-- Consulta realitzada correctament
		GESTIO_COMPRES.CNS_COMPRES(v_rs, 1, v_JugadorId, v_resultat);
		FETCH v_rs INTO v_recordset;
		IF v_rs%FOUND  THEN
			DBMS_OUTPUT.put_line ('OK: Consulta amb resultats.');
		ELSE
			DBMS_OUTPUT.put_line ('KO: Consulta sense resultats.');
		END IF;
				
		-- Error parmetres obligatoris 
		GESTIO_COMPRES.CNS_COMPRES(v_rs, null, v_JugadorId, v_resultat);
		
		-- Error jugador no trobat
		GESTIO_COMPRES.CNS_COMPRES(v_rs, 1, 99, v_resultat);
		
		-- Error joc no trobat
		GESTIO_COMPRES.CNS_COMPRES(v_rs, 99, v_JugadorId, v_resultat);
             
              					
		rollback;

END TEST_GESTIO_COMPRES;


END TEST_G_GESTIO_COMPRES;


/
