---------------------------------------------------------------------------------
-- Alumne: Jessica Villamor 
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO DE VIDEOJOCS
---------------------------------------------------------------------------------

-- Procediment Test: Gesti d'Estats

--
-- Ens situem a l'esquema de la base de dades de Gesti de Videojocs
--
ALTER SESSION SET CURRENT_SCHEMA = PFCBD;

-- Creaci de la definici del paquet
Create or replace
PACKAGE PFCBD.TEST_DM_ESTATS AS
		
		PROCEDURE TEST_ESTATS;
		
END TEST_DM_ESTATS;
/

-- Creaci del cos del paquet
CREATE OR REPLACE PACKAGE BODY PFCBD.TEST_DM_ESTATS AS
 
    PROCEDURE TEST_ESTATS
    IS
		v_resultat PFCBD.LOG.RESULTAT%TYPE;
		v_rs sys_refcursor;
		
		v_level integer;
		v_estant_id number;
		v_id number;
		v_nom varchar(10);
		v_descriptiu varchar(25);

    BEGIN

		-- Test INS_ESTATS
		-- PROCEDURE INS_ESTATS( p_nom IN PFCBD.ESTATS.NOM%TYPE, p_desc IN PFCBD.ESTATS.DESCRIPTIU%TYPE, p_nivant IN PFCBD.ESTATS.ESTANT_ID%TYPE, p_resultat OUT VARCHAR);

		-- S'insereix un estat de forma correcta
		DM_ESTATS.INS_ESTATS('ZZZ', 'Estat A', null, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- S'insereix un estat de forma correcta
		DM_ESTATS.INS_ESTATS('YYY', 'Estat B', null, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- S'insereix un estat que ja existeix
		DM_ESTATS.INS_ESTATS('YYY', 'Estat C', null, v_resultat);

		-- S'insereix un estat amb el descriptiu buit
		DM_ESTATS.INS_ESTATS('VVV',  null, null, v_resultat);

		-- S'insereix un estat amb error d'integritat referencial
		DM_ESTATS.INS_ESTATS('WWW', 'Estat C', 999,  v_resultat);


		-- Test UPD_ESTATS
		-- PROCEDURE UPD_ESTATS ( p_id IN PFCBD.ESTATS.ID%TYPE, p_nom IN PFCBD.ESTATS.NOM%TYPE, p_desc IN PFCBD.ESTATS.DESCRIPTIU%TYPE, p_nivant IN PFCBD.ESTATS.ESTANT_ID%TYPE, p_resultat OUT VARCHAR);
		-- PROCEDURE CNS_ESTATS ( p_rs IN OUT sys_refcursor, p_id IN PFCBD.ESTATS.ID%TYPE, p_nom IN PFCBD.ESTATS.NOM%TYPE, p_resultat OUT VARCHAR);

		-- Es consulta l'estat a actualitzar
		DM_ESTATS.CNS_ESTATS (v_rs, null, 'ZZZ', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- Actualitzaci de l'estat
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_level, v_estant_id, v_id, v_nom, v_descriptiu;
         
			  EXIT WHEN v_rs%NOTFOUND;
				--	Actualitzaci correcta
			   DM_ESTATS.UPD_ESTATS (v_id, 'ZZZ', 'Estat A Actualitzat', null,  v_resultat);
 			   DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;

   		--	Error: Actualitzaci amb un nom d'estat que ja existeix
		DM_ESTATS.UPD_ESTATS (v_id, 'YYY', 'Estat B Actualitzat', null,  v_resultat);

  		--	Error: Actualitzaci amb el nom i el descriptiu de l'estat buit
		DM_ESTATS.UPD_ESTATS (v_id, null, 'Estat B Actualitzat', null, v_resultat);
		DM_ESTATS.UPD_ESTATS (v_id, 'ZZZ', null, null, v_resultat);

		--	Error: Actualitzaci amb un estat anterior que no existeix
		DM_ESTATS.UPD_ESTATS (v_id, 'ZZZ', 'Estat A Actualitzat', 999, v_resultat);

        --	Error: Identificador no informat
		DM_ESTATS.UPD_ESTATS (null, 'ZZZ', 'Estat A Actualitzat', null, v_resultat);


		-- Test DEL_ESTATS
		-- PROCEDURE DEL_ESTATS(p_id IN PFCBD.ESTATS.ID%TYPE, p_resultat OUT VARCHAR);

		-- Esborrat correcte
		DM_ESTATS.DEL_ESTATS (v_id, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- Error: Esborrat estat no existent
		DM_ESTATS.DEL_ESTATS (999, v_resultat);

		-- Error: Esborrat error per identificador buit
		DM_ESTATS.DEL_ESTATS (null, v_resultat);

		-- Error: Intentar esborrar registre amb dependncies
		DM_ESTATS.DEL_ESTATS (1, v_resultat);


		-- Test CNS_ESTATS
		-- PROCEDURE CNS_ESTATS(p_rs IN OUT sys_refcursor, p_id IN PFCBD.ESTATS.ID%TYPE, p_resultat OUT VARCHAR);

		-- Consulta correcta
		DM_ESTATS.CNS_ESTATS (v_rs, null, 'YYY', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- Esborrat del navegador de test creat, per no deixar dades de test a la BD.
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			 	  FETCH v_rs INTO v_level, v_estant_id, v_id, v_nom, v_descriptiu;
			  EXIT WHEN v_rs%NOTFOUND;
				 DM_ESTATS.DEL_ESTATS (v_id, v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;
  

END TEST_ESTATS;


END TEST_DM_ESTATS;


/
