---------------------------------------------------------------------------------
-- Alumne: Jessica Villamor 
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO DE VIDEOJOCS
---------------------------------------------------------------------------------

-- Procediment Test: Gesti de dades de Jocs

--
-- Ens situem a l'esquema de la base de dades de Gesti de Videojocs
--
ALTER SESSION SET CURRENT_SCHEMA = PFCBD;

Create or replace
PACKAGE PFCBD.TEST_DM_JOCS AS
		
		PROCEDURE TEST_JOCS;
		
	
END TEST_DM_JOCS;
/


CREATE OR REPLACE PACKAGE BODY PFCBD.TEST_DM_JOCS AS
 
    PROCEDURE TEST_JOCS
    IS
		v_resultat PFCBD.LOG.RESULTAT%TYPE;
		v_rs sys_refcursor;
		v_record JOCS%ROWTYPE;

    BEGIN

		-- Test INS_JOCS
		-- PROCEDURE INS_JOCS ( nom IN PFCBD.jocs.nom%TYPE, vides IN PFCBD.jocs.vides%TYPE, p_resultat OUT VARCHAR);

		-- S'insereix un Joc de forma correcta
		DM_JOCS.INS_JOCS('Joc A', 0,  v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- S'insereix un Joc de forma correcta
		DM_JOCS.INS_JOCS('Joc B', 0,  v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- S'insereix un joc que ja existeix
		DM_JOCS.INS_JOCS('Joc B', 0,  v_resultat);

		-- S'insereix un joc amb el nom buit
		DM_JOCS.INS_JOCS('', 0,  v_resultat);

						
		-- Test UPD_JOCS
		-- PROCEDURE UPD_JOCS ( p_id IN PFCBD.jocs.id%TYPE, p_nom IN PFCBD.jocs.nom%TYPE, p_vides IN PFCBD.jocs.vides%TYPE, p_resultat OUT VARCHAR);
		-- PROCEDURE CNS_JOCS ( p_rs IN OUT	sys_refcursor, p_id	IN	PFCBD.jocs.id%TYPE,	p_nom IN PFCBD.jocs.nom%TYPE, p_resultat OUT VARCHAR);
				
		-- Es consulta el joc a actualitzar
		DM_JOCS.CNS_JOCS (v_rs, '', 'Joc A', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- Actualitzaci del Joc
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_record;
			  EXIT WHEN v_rs%NOTFOUND;
				 --	Actualización correcta
				 DM_JOCS.UPD_JOCS ( v_record.ID, 'Joc A Actualitzat', 0, v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;
 
  		--	Error: Actualitzaci amb un nom de Joc que ja existeix
		DM_JOCS.UPD_JOCS ( v_record.ID, 'Joc B', 0, v_resultat);
		
  		--	Error: Actualitzaci amb un nom de Joc buit
		DM_JOCS.UPD_JOCS ( v_record.ID, null, 0, v_resultat);

		--	Error: Actualitzaci d'un joc no existent
		DM_JOCS.UPD_JOCS ( 999, null, 0, v_resultat);
 
						 
		-- Test DEL_JOCS
		-- PROCEDURE DEL_JOCS (p_id IN PFCBD.jocs.id%TYPE, p_resultat OUT VARCHAR);
		
		-- Esborrat correcte
		DM_JOCS.DEL_JOCS ( v_record.ID, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- Error: Esborrat error Joc no existent
		DM_JOCS.DEL_JOCS (999, v_resultat);
		
		-- Error: Esborrat d'un registre amb dependncies
		DM_JOCS.DEL_JOCS (1, v_resultat);
		

					
		-- Test CNS_JOCS
		-- PROCEDURE CNS_JOCS (p_rs IN OUT	sys_refcursor, p_id	IN	PFCBD.jocs.id%TYPE,	p_nom IN PFCBD.jocs.nom%TYPE, p_resultat OUT VARCHAR);
								
		-- Consulta correcta
		DM_JOCS.CNS_JOCS (v_rs, '', 'Joc B', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- Esborrat del joc de test creat, per no deixar dades de test a la BD.
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_record;
			  EXIT WHEN v_rs%NOTFOUND;
				 DM_JOCS.DEL_JOCS (v_record.ID, v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;
 
END TEST_JOCS;


END TEST_DM_JOCS;


/
