---------------------------------------------------------------------------------
-- Alumne: Jessica Villamor 
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO DE VIDEOJOCS
---------------------------------------------------------------------------------

-- Procediment Test: Gesti de Navegadors

--
-- Ens situem a l'esquema de la base de dades de Gesti de Videojocs
--
ALTER SESSION SET CURRENT_SCHEMA = PFCBD;

-- Creaci de la definici del paquet
Create or replace
PACKAGE PFCBD.TEST_DM_NAVEGADORS AS
		
		PROCEDURE TEST_NAVEGADORS;
		
	
END TEST_DM_NAVEGADORS;
/


-- Creaci del cos del paquet
CREATE OR REPLACE PACKAGE BODY PFCBD.TEST_DM_NAVEGADORS AS
 
    PROCEDURE TEST_NAVEGADORS
    IS
		v_resultat PFCBD.LOG.RESULTAT%TYPE;
		v_rs sys_refcursor;
		v_record NAVEGADORS%ROWTYPE;

    BEGIN

		-- Test INS_NAVEGADORS
		-- PROCEDURE INS_NAVEGADORS( p_nom IN PFCBD.NAVEGADORS.NOM%TYPE, p_resultat OUT VARCHAR)

		-- S'insereix un navegador de forma correcta
		DM_NAVEGADORS.INS_NAVEGADORS('Navegador A', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- S'insereix un navegador de forma correcta
		DM_NAVEGADORS.INS_NAVEGADORS('Navegador B', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- S'insereix un navegador que ja existeix
		DM_NAVEGADORS.INS_NAVEGADORS('Navegador A', v_resultat);

		-- S'insereix un navegador amb el nom buit
		DM_NAVEGADORS.INS_NAVEGADORS('', v_resultat);

						
		-- UPD_NAVEGADORS
		-- PROCEDURE UPD_NAVEGADORS ( p_id IN PFCBD.NAVEGADORS.ID%TYPE, p_nom IN PFCBD.NAVEGADORS.NOM%TYPE, p_resultat OUT VARCHAR);
		-- PROCEDURE CNS_NAVEGADORS (p_rs IN OUT sys_refcursor, p_id IN PFCBD.NAVEGADORS.id%TYPE, p_nom IN PFCBD.NAVEGADORS.NOM%TYPE, p_resultat OUT VARCHAR);
				
		-- Es consulta el navegador a actualitzar
		DM_NAVEGADORS.CNS_NAVEGADORS (v_rs, '', 'Navegador A', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- Actualitzaci del Navegador
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_record;
			  EXIT WHEN v_rs%NOTFOUND;
				 --	Actualitzaci correcta
				 DM_NAVEGADORS.UPD_NAVEGADORS ( v_record.ID, 'Navegador A Actualitzat', v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;
 
  		--	Error: Actualitzaci amb un nom de Navegador que ja existeix
		DM_NAVEGADORS.UPD_NAVEGADORS ( v_record.ID, 'Navegador B', v_resultat);
		
  		--	Error: Actualitzaci amb un nom de Navegador buit
		DM_NAVEGADORS.UPD_NAVEGADORS ( v_record.ID, '', v_resultat);

		--	Error: Actualitzaci d'un navegador no existent
		DM_NAVEGADORS.UPD_NAVEGADORS ( 999, 'No existeix', v_resultat);
 
        --	Error: Identificador no informat
		DM_NAVEGADORS.UPD_NAVEGADORS ( '', 'buit', v_resultat);


		-- DEL_NAVEGADORS
		-- PROCEDURE DEL_NAVEGADORS (p_id IN PFCBD.NAVEGADORS.id%TYPE, p_resultat OUT VARCHAR);		
		
		-- Esborrat correcte
		DM_NAVEGADORS.DEL_NAVEGADORS (v_record.ID, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- Error: Esborrat error per identificador buit
		DM_NAVEGADORS.DEL_NAVEGADORS ('', v_resultat);
		
		-- Error: Esborrat error navegador no existent
		DM_NAVEGADORS.DEL_NAVEGADORS (999, v_resultat);
		
		-- Error: Intentar esborrar registre amb dependncies
		DM_NAVEGADORS.DEL_NAVEGADORS (1, v_resultat);
		

		-- CNS_NAVEGADORS
		-- PROCEDURE CNS_NAVEGADORS (p_rs IN OUT sys_refcursor, p_id IN PFCBD.NAVEGADORS.id%TYPE, p_nom IN PFCBD.NAVEGADORS.NOM%TYPE, p_resultat OUT VARCHAR);
								
		-- Consulta correcta
		DM_NAVEGADORS.CNS_NAVEGADORS (v_rs, '', 'Navegador B', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- Esborrat del navegador de test creat, per no deixar dades de test a la BD.
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_record;
			  EXIT WHEN v_rs%NOTFOUND;
				 DM_NAVEGADORS.DEL_NAVEGADORS (v_record.ID, v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;
 
   
END TEST_NAVEGADORS;


END TEST_DM_NAVEGADORS;


/
