---------------------------------------------------------------------------------
-- Alumne: Jessica Villamor 
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO DE VIDEOJOCS
---------------------------------------------------------------------------------

-- Procediment Test: Gesti de dades de Nivells

--
-- Ens situem a l'esquema de la base de dades de Gesti de Videojocs
--
ALTER SESSION SET CURRENT_SCHEMA = PFCBD;

Create or replace
PACKAGE PFCBD.TEST_DM_NIVELLS AS
		
		PROCEDURE TEST_NIVELLS;
		
	
END TEST_DM_NIVELLS;
/


CREATE OR REPLACE PACKAGE BODY PFCBD.TEST_DM_NIVELLS AS
 
    PROCEDURE TEST_NIVELLS
    IS
		v_resultat PFCBD.LOG.RESULTAT%TYPE;
		v_rs sys_refcursor;
		
		v_level integer;
		v_jocs_id number;
		v_id number;
		v_nom varchar(255);
		v_nivseg number;

    BEGIN

		-- Test INS_NIVELLS
		-- PROCEDURE INS_NIVELLS ( p_joc_id IN PFCBD.NIVELLS.JOCS_ID%TYPE, p_nom IN PFCBD.NIVELLS.NOM%TYPE, p_segniv IN PFCBD.NIVELLS.NIVSEG_ID%TYPE, p_resultat OUT VARCHAR);

		-- S'insereix un Nivell de forma correcta
		DM_NIVELLS.INS_NIVELLS(1, 'Nivell A', null,  v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- S'insereix un Nivell de forma correcta
		DM_NIVELLS.INS_NIVELLS(1, 'Nivell B', null,  v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- S'insereix un nivell que ja existeix
		DM_NIVELLS.INS_NIVELLS(1, 'Nivell B', null,  v_resultat);

		-- S'insereix un nivell amb el nom buit
		DM_NIVELLS.INS_NIVELLS(1, '', null,  v_resultat);
		
		-- S'insereix un nivell amb l'identificador d'un joc no existent
		DM_NIVELLS.INS_NIVELLS(99, '', null,  v_resultat);
		
		-- S'insereix un nivell amb l'identificador del nivell segent no existent
		DM_NIVELLS.INS_NIVELLS(1, 'Nivell C', 99,  v_resultat);
       

		-- Test UPD_NIVELLS
		-- PROCEDURE UPD_NIVELLS ( p_id IN PFCBD.NIVELLS.id%TYPE, p_joc_id IN PFCBD.NIVELLS.JOCS_ID%TYPE, p_nom IN PFCBD.NIVELLS.NOM%TYPE, p_segniv IN PFCBD.NIVELLS.NIVSEG_ID%TYPE, p_resultat OUT VARCHAR);
		-- PROCEDURE CNS_NIVELLS ( p_rs IN OUT	sys_refcursor, 	p_id IN PFCBD.NIVELLS.id%TYPE, 	p_joc_id IN PFCBD.NIVELLS.JOCS_ID%TYPE, p_nom IN PFCBD.NIVELLS.NOM%TYPE, p_segniv IN PFCBD.NIVELLS.NIVSEG_ID%TYPE, p_resultat OUT VARCHAR);
				
		-- Es consulta el Nivell a actualitzar
		DM_NIVELLS.CNS_NIVELLS (v_rs, '', 1 ,'Nivell A', null, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- Actualitzaci del Nivell
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_level, v_jocs_id, v_id, v_nom, v_nivseg;
			  EXIT WHEN v_rs%NOTFOUND;
				 --	Actualización correcta
				 DM_NIVELLS.UPD_NIVELLS ( v_id, 1, 'Nivell A Actualitzat', null, v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;
 
  		--	Error: Actualitzaci amb un nom de Nivell que ja existeix
		DM_NIVELLS.UPD_NIVELLS ( v_id, 1, 'Nivell B', null, v_resultat);
		
  		--	Error: Actualitzaci amb un nom de Nivell buit
		DM_NIVELLS.UPD_NIVELLS ( v_id, 1, '', null, v_resultat);

		--	Error: Actualitzaci d'un nivell amb joc no existent
		DM_NIVELLS.UPD_NIVELLS ( v_id, 99, '', null, v_resultat);
 
		--	Error: Actualitzaci d'un nivell amb nivell següent no existent
		DM_NIVELLS.UPD_NIVELLS ( v_id, 1, 'Nivell A Act', 99, v_resultat);
 						 

				
		-- Test DEL_NIVELLS
		-- PROCEDURE DEL_NIVELLS (p_id IN PFCBD.NIVELLS.id%TYPE, p_resultat OUT VARCHAR);
		
		-- Esborrat correcte
		DM_NIVELLS.DEL_NIVELLS (v_id, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- Error: Esborrat d'un registre amb dependncies
		DM_NIVELLS.DEL_NIVELLS (1, v_resultat);
		
		-- Error: Esborrat error Nivell no existent
		DM_NIVELLS.DEL_NIVELLS (999, v_resultat);
		
					
		-- Test CNS_NIVELLS
		-- PROCEDURE CNS_NIVELLS ( p_rs IN OUT	sys_refcursor, 	p_id IN PFCBD.NIVELLS.id%TYPE, 	p_joc_id IN PFCBD.NIVELLS.JOCS_ID%TYPE, p_nom IN PFCBD.NIVELLS.NOM%TYPE, p_segniv IN PFCBD.NIVELLS.NIVSEG_ID%TYPE, p_resultat OUT VARCHAR)

		-- Error: Consulta dels nivells d'un joc que no existeix
		DM_NIVELLS.CNS_NIVELLS (v_rs, '', 99 , null, null, v_resultat);
		
		-- Error: Consulta un nivell que no existeix
		DM_NIVELLS.CNS_NIVELLS (v_rs, 99, 1 , null, null, v_resultat);

		-- Error: Consulta sense criteris de selecci
		DM_NIVELLS.CNS_NIVELLS (v_rs, null, null, null, null, v_resultat);
		
		-- Consulta correcta
		DM_NIVELLS.CNS_NIVELLS (v_rs, '', 1 ,'Nivell B', null, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		
		-- Esborrat del Nivell de test creat, per no deixar dades de test a la BD.
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_level, v_jocs_id, v_id, v_nom, v_nivseg;
			  EXIT WHEN v_rs%NOTFOUND;
				 DM_NIVELLS.DEL_NIVELLS (v_id, v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;
 
 							
END TEST_NIVELLS;


END TEST_DM_NIVELLS;


/
