---------------------------------------------------------------------------------
-- Alumne: Jessica Villamor 
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO DE VIDEOJOCS
---------------------------------------------------------------------------------

-- Procediment Test: Gestió de Paisos

--
-- Ens situem a l'esquema de la base de dades de Gesti de Videojocs
--
ALTER SESSION SET CURRENT_SCHEMA = PFCBD;

-- Creaci de la definici del paquet
Create or replace
PACKAGE PFCBD.TEST_DM_PAISOS AS
		
		PROCEDURE TEST_PAISOS;
		
	
END TEST_DM_PAISOS;
/


-- Creaci del cos del paquet
CREATE OR REPLACE PACKAGE BODY PFCBD.TEST_DM_PAISOS AS
 
    PROCEDURE TEST_PAISOS
    IS
		v_resultat PFCBD.LOG.RESULTAT%TYPE;
		v_rs sys_refcursor;
		v_record PAISOS%ROWTYPE;

    BEGIN

		-- Test INS_PAISOS
		-- PROCEDURE INS_PAISOS( p_codi IN PFCBD.PAISOS.CODPAIS%TYPE, p_nom IN PFCBD.PAISOS.NOM%TYPE, p_resultat OUT VARCHAR);

		-- S'insereix un pas de forma correcta
		DM_PAISOS.INS_PAISOS('00', 'Pas A', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- S'insereix un pas de forma correcta
		DM_PAISOS.INS_PAISOS('01', 'Pas B', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
	
		-- S'insereix un pas que ja existeix
		DM_PAISOS.INS_PAISOS('00', 'Pas A', v_resultat);

		-- S'insereix un pas amb l'identificador buit
		DM_PAISOS.INS_PAISOS('', 'Pas C', v_resultat);

		-- S'insereix un pas amb el nom buit
		DM_PAISOS.INS_PAISOS('02', '', v_resultat);
				
				
		-- UPD_PAISOS
		-- PROCEDURE UPD_PAISOS( p_codi IN PFCBD.PAISOS.CODPAIS%TYPE, p_nom IN PFCBD.PAISOS.NOM%TYPE, p_resultat OUT VARCHAR);
		-- PROCEDURE CNS_PAISOS(p_rs IN OUT sys_refcursor, p_codi IN PFCBD.PAISOS.codpais%TYPE, p_nom IN PFCBD.PAISOS.NOM%TYPE, p_resultat OUT VARCHAR);
				
		-- Es consulta el pas a actualitzar
		DM_PAISOS.CNS_PAISOS(v_rs,'00', '', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- Actualitzaci del pas
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_record;
			  EXIT WHEN v_rs%NOTFOUND;
				 --	Actualitzaci correcta
				 DM_PAISOS.UPD_PAISOS('00', 'Pas A Actualitzat', v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;
 
		-- Error: Actualitzaci amb el nom de pas buit
		DM_PAISOS.UPD_PAISOS( v_record.CODPAIS, '', v_resultat);
		
		--	Error: Actualitzaci d'un pas que no existeix
		DM_PAISOS.UPD_PAISOS( '99', 'Paix inexistent', v_resultat);
 
        --	Error: Identificador no informat
		DM_PAISOS.UPD_PAISOS ( '', 'buit', v_resultat);
		
		

		-- DEL_PAISOS
		-- PROCEDURE DEL_PAISOS(p_codi IN PFCBD.PAISOS.codpais%TYPE, p_resultat OUT VARCHAR);	
		
		-- Esborrat correcte
		DM_PAISOS.DEL_PAISOS (v_record.CODPAIS, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
				
		
		-- Error: Esborrat error per identificador buit
		DM_PAISOS.DEL_PAISOS ('', v_resultat);
		
		
		-- Error: Esborrat error pas no existent
		DM_PAISOS.DEL_PAISOS  (999, v_resultat);
		
		-- Error: Intentar esborrar registre amb dependncies
		DM_PAISOS.DEL_PAISOS ('ES', v_resultat);
		
		
		-- CNS_NAVEGADORS
		-- PROCEDURE CNS_PAISOS(p_rs IN OUT sys_refcursor, p_codi IN PFCBD.PAISOS.codpais%TYPE, p_nom IN PFCBD.PAISOS.NOM%TYPE, p_resultat OUT VARCHAR);
								
		-- Consulta correcta
		DM_PAISOS.CNS_PAISOS (v_rs, '01', '', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- Esborrat del pas de test creat, per no deixar dades de test a la BD.
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_record;
			  EXIT WHEN v_rs%NOTFOUND;
				 DM_PAISOS.DEL_PAISOS (v_record.CODPAIS, v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;
    

END TEST_PAISOS;


END TEST_DM_PAISOS;


/
