---------------------------------------------------------------------------------
-- Alumne: Jessica Villamor 
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO DE VIDEOJOCS
---------------------------------------------------------------------------------

-- Procediment Test: Gesti de Plataformes

--
-- Ens situem a l'esquema de la base de dades de Gesti de Videojocs
--
ALTER SESSION SET CURRENT_SCHEMA = PFCBD;

-- Creaci de la definici del paquet
Create or replace
PACKAGE PFCBD.TEST_DM_PLATAFORMES AS
		
		PROCEDURE TEST_PLATAFORMES;
		
	
END TEST_DM_PLATAFORMES;
/

-- Creaci del cos del paquet
CREATE OR REPLACE PACKAGE BODY PFCBD.TEST_DM_PLATAFORMES AS
 
    PROCEDURE TEST_PLATAFORMES
    IS
		v_resultat PFCBD.LOG.RESULTAT%TYPE;
		v_rs sys_refcursor;
    v_record PLATAFORMES%ROWTYPE;

    BEGIN

		-- INS_PLATAFORMES

		-- S'insereix una plataforma de forma correcta
		DM_PLATAFORMES.INS_PLATAFORMES('Plataforma A', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- S'insereix una plataforma de forma correcta
		DM_PLATAFORMES.INS_PLATAFORMES('Plataforma B', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- S'insereix una plataforma que ja existeix
		DM_PLATAFORMES.INS_PLATAFORMES('Plataforma A', v_resultat);

		-- S'insereix una plataforma amb el nom buit
		DM_PLATAFORMES.INS_PLATAFORMES('', v_resultat);


		-- UPD_PLATAFORMES
				
		-- Es consulta la plataforma a actualitzar
		DM_PLATAFORMES.CNS_PLATAFORMES (v_rs, '', 'Plataforma A', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- Actualitzaci de la plataforma
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_record;
			  EXIT WHEN v_rs%NOTFOUND;
				 --	Actualitzaci correcta
				 DM_PLATAFORMES.UPD_PLATAFORMES ( v_record.ID, 'Plataforma A Actualitzada', v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;
 
		--	Error: Actualitzaci amb un nom de Plataforma que ja existeix
		DM_PLATAFORMES.UPD_PLATAFORMES ( v_record.ID, 'Plataforma B', v_resultat);
		
  		--	Error: Actualitzaci amb un nom de plataforma buit
		DM_PLATAFORMES.UPD_PLATAFORMES ( v_record.ID, '', v_resultat);

		--	Error: Actualitzaci d'una plataforma no existent
		DM_PLATAFORMES.UPD_PLATAFORMES ( 999, 'No existeix', v_resultat);
 
        --	Error: Identificador no informat
		DM_PLATAFORMES.UPD_PLATAFORMES ( '', 'buit', v_resultat);

		

		-- DEL_PLATAFORMES		
		
		-- Esborrat correcte
		DM_PLATAFORMES.DEL_PLATAFORMES (v_record.ID, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- Error: Esborrat error per identificador buit
		DM_PLATAFORMES.DEL_PLATAFORMES ('', v_resultat);
		
		-- Error: Esborrat error plataforma no existent
		DM_PLATAFORMES.DEL_PLATAFORMES (999, v_resultat);
		
		-- Error: Intentar esborrar registre amb dependncies
		DM_PLATAFORMES.DEL_PLATAFORMES (1, v_resultat);
		

		-- CNS_PLATAFORMES
		-- Consulta correcta
		DM_PLATAFORMES.CNS_PLATAFORMES (v_rs, '', 'Plataforma B', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- Esborrat de les plataformes creades per no deixar dades de test a la BD.
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_record;
			  EXIT WHEN v_rs%NOTFOUND;
				 DM_PLATAFORMES.DEL_PLATAFORMES (v_record.ID, v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;
 

END TEST_PLATAFORMES;


END TEST_DM_PLATAFORMES;


/
