---------------------------------------------------------------------------------
-- Alumne: Jessica Villamor 
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO DE VIDEOJOCS
---------------------------------------------------------------------------------

-- Procediment Test: Gesti de Poblacions

--
-- Ens situem a l'esquema de la base de dades de Gesti de Videojocs
--
ALTER SESSION SET CURRENT_SCHEMA = PFCBD;

-- Creaci de la definici del paquet
Create or replace
PACKAGE PFCBD.TEST_DM_POBLACIONS AS
		
		PROCEDURE TEST_POBLACIONS;
		
	
END TEST_DM_POBLACIONS;
/

-- Creaci del cos del paquet
CREATE OR REPLACE PACKAGE BODY PFCBD.TEST_DM_POBLACIONS AS
 
    PROCEDURE TEST_POBLACIONS
    IS
		v_resultat PFCBD.LOG.RESULTAT%TYPE;
		v_rs sys_refcursor;
		v_record POBLACIONS%ROWTYPE;

    BEGIN

		-- Test INS_POBLACIONS
		-- PROCEDURE INS_POBLACIONS( p_codPais IN PFCBD.POBLACIONS.CODPAIS%TYPE, p_codProv IN PFCBD.POBLACIONS.CODPROV%TYPE, p_codPob IN PFCBD.POBLACIONS.CODPOB%TYPE, p_nom IN PFCBD.POBLACIONS.NOM%TYPE, p_resultat OUT VARCHAR);

		-- S'insereix una poblaci de forma correcta
		DM_POBLACIONS.INS_POBLACIONS('ES', '08' , '99990', 'Poblaci A', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- S'insereix una poblaci de forma correcta
		DM_POBLACIONS.INS_POBLACIONS('ES', '08' , '99991', 'Poblaci B', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- S'insereix una poblaci que ja existeix
		DM_POBLACIONS.INS_POBLACIONS('ES', '08', '08001', 'Abrera',  v_resultat);
	
		-- S'insereix una poblaci amb nom buit
		DM_POBLACIONS.INS_POBLACIONS('ES', '08', '99992', null, v_resultat);
	
		-- S'insereix una poblaci amb un codi de pais inexistent, error d'integritat referencial
		DM_POBLACIONS.INS_POBLACIONS('00', '08', '99993', 'Poblaci C', v_resultat);
			
		
					
		-- Test UPD_POBLACIONS
		-- PROCEDURE UPD_POBLACIONS ( p_codPais IN PFCBD.POBLACIONS.CODPAIS%TYPE, p_codProv IN PFCBD.POBLACIONS.CODPROV%TYPE, p_codPob IN PFCBD.POBLACIONS.CODPOB%TYPE, p_nom IN PFCBD.POBLACIONS.NOM%TYPE, p_resultat OUT VARCHAR);
		-- PROCEDURE CNS_POBLACIONS(p_rs IN OUT sys_refcursor, p_codPais IN PFCBD.POBLACIONS.CODPAIS%TYPE, p_codProv IN PFCBD.POBLACIONS.CODPROV%TYPE, p_codPob  IN PFCBD.POBLACIONS.CODPOB%TYPE, p_nom  IN PFCBD.POBLACIONS.NOM%TYPE, p_resultat OUT VARCHAR);
				
		-- Es consulta la poblaci a actualitzar
		DM_POBLACIONS.CNS_POBLACIONS(v_rs,'ES', '08','99990', '', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- Actualitzaci de la poblaci
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_record;
			  EXIT WHEN v_rs%NOTFOUND;
				 --	Actualitzaci correcta
				 DM_POBLACIONS.UPD_POBLACIONS('ES', '08','99990', 'Poblaci A Actualitzada', v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;
 
		-- Error: Actualitzaci amb el nom de la poblaci buida
		DM_POBLACIONS.UPD_POBLACIONS('ES', '08','99990', null, v_resultat);
		
		--	Error: Actualitzaci d'una poblaci que no existeix
		DM_POBLACIONS.UPD_POBLACIONS( 'ES', '08', '99999', 'Poblaci', v_resultat);
 
        --	Error: Identificador no informat
		DM_POBLACIONS.UPD_POBLACIONS( null, '08', '99990', 'Poblaci', v_resultat);
		DM_POBLACIONS.UPD_POBLACIONS( 'ES', null, '99990', 'Poblaci', v_resultat);
		DM_POBLACIONS.UPD_POBLACIONS( 'ES', '08', null, 'Poblaci', v_resultat);
		
		
		-- Test DEL_POBLACIONS
		-- PROCEDURE DEL_POBLACIONS(p_codPais IN PFCBD.POBLACIONS.CODPAIS%TYPE, p_codProv IN PFCBD.POBLACIONS.CODPROV%TYPE, p_codPob IN PFCBD.POBLACIONS.CODPOB%TYPE, p_resultat OUT VARCHAR);
		
		-- Esborrat correcte
		DM_POBLACIONS.DEL_POBLACIONS ('ES', '08', '99990', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
				
		-- Error: Esborrat error poblaci no existent
		DM_POBLACIONS.DEL_POBLACIONS ('ES', '08', '99999',  v_resultat);
					
		-- Error: Esborrat error per identificador buit
		DM_POBLACIONS.DEL_POBLACIONS ( null, '08', '99990', v_resultat);
		DM_POBLACIONS.DEL_POBLACIONS ( 'ES', null, '99990', v_resultat);
		DM_POBLACIONS.DEL_POBLACIONS ( 'ES', '08', null, v_resultat);
		
		-- Error: Intentar esborrar registre amb dependncies
		DM_POBLACIONS.DEL_POBLACIONS ('ES', '08', '08077', v_resultat);
						
				
		-- Test CNS_POBLACIONS
		-- PROCEDURE CNS_POBLACIONS(p_rs IN OUT sys_refcursor, p_codPais IN PFCBD.POBLACIONS.CODPAIS%TYPE, p_codProv IN PFCBD.POBLACIONS.CODPROV%TYPE, p_codPob  IN PFCBD.POBLACIONS.CODPOB%TYPE, p_nom  IN PFCBD.POBLACIONS.NOM%TYPE, p_resultat OUT VARCHAR);

			
		-- Consulta incorrecta per falta de criteris de selecci
		DM_POBLACIONS.CNS_POBLACIONS (v_rs, null, null, null, null, v_resultat);
						  
		-- Consulta correcta
		DM_POBLACIONS.CNS_POBLACIONS (v_rs, 'ES', '08', '99991', '', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- Esborrat la poblaci de test creada, per no deixar dades de test a la BD.
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_record;
			  EXIT WHEN v_rs%NOTFOUND;
				 DM_POBLACIONS.DEL_POBLACIONS (v_record.CODPAIS, v_record.CODPROV, v_record.CODPOB, v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;
   

END TEST_POBLACIONS;


END TEST_DM_POBLACIONS;


/
