---------------------------------------------------------------------------------
-- Alumne: Jessica Villamor 
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO DE VIDEOJOCS
---------------------------------------------------------------------------------
--
-- Procediment Test: Gesti de dades de Productes
--
--
-- Ens situem a l'esquema de la base de dades de Gesti de Videojocs
--
ALTER SESSION SET CURRENT_SCHEMA = PFCBD;

Create or replace
PACKAGE PFCBD.TEST_DM_PRODUCTES AS
		
		PROCEDURE TEST_PRODUCTES;
		
	
END TEST_DM_PRODUCTES;
/


CREATE OR REPLACE PACKAGE BODY PFCBD.TEST_DM_PRODUCTES AS
 
    PROCEDURE TEST_PRODUCTES
    IS
		v_resultat PFCBD.LOG.RESULTAT%TYPE;
		v_rs sys_refcursor;
		v_record PRODUCTES%ROWTYPE;

    BEGIN

		-- Test INS_PRODUCTES
		-- PROCEDURE INS_PRODUCTES( p_joc_id IN PFCBD.PRODUCTES.JOCS_ID%TYPE, p_nom IN PFCBD.PRODUCTES.NOM%TYPE, p_tip IN PFCBD.PRODUCTES.TIPOLOGIA%TYPE, p_preu IN PFCBD.PRODUCTES.PREU%TYPE, p_dataBaixa IN PFCBD.PRODUCTES.DATABAIXA%TYPE, p_resultat OUT VARCHAR);

		-- S'insereix un Producte de forma correcta
		DM_PRODUCTES.INS_PRODUCTES(1, 'Producte A', 'VI', 0, null, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- S'insereix un Producte de forma correcta
		DM_PRODUCTES.INS_PRODUCTES(1, 'Producte B', 'VI', 0, null, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
	
		-- S'insereix un producte amb valors nuls
		DM_PRODUCTES.INS_PRODUCTES(null, 'Producte C', 'VI', 0, null, v_resultat);
		DM_PRODUCTES.INS_PRODUCTES(1, null, 'VI', 0, null, v_resultat);
		DM_PRODUCTES.INS_PRODUCTES(1, 'Producte C', null, 0, null, v_resultat);
		DM_PRODUCTES.INS_PRODUCTES(1, 'Producte C', 'VI', null, null, v_resultat);

		-- S'insereix un producte en un id joc que no existeix
		DM_PRODUCTES.INS_PRODUCTES(99, 'Producte C', 'VI', 0, null, v_resultat);		

		-- S'insereix un producte amb tipologia incorrecta
		DM_PRODUCTES.INS_PRODUCTES(1, 'Producte C', 'ZZ', 0, null, v_resultat);

						
		-- Test UPD_PRODUCTES
		-- PROCEDURE UPD_PRODUCTES ( p_id IN PFCBD.PRODUCTES.ID%TYPE, p_joc_id IN PFCBD.PRODUCTES.JOCS_ID%TYPE, p_nom IN PFCBD.PRODUCTES.NOM%TYPE, p_tip IN PFCBD.PRODUCTES.TIPOLOGIA%TYPE, p_preu IN PFCBD.PRODUCTES.PREU%TYPE, p_dataBaixa IN PFCBD.PRODUCTES.DATABAIXA%TYPE, p_resultat OUT VARCHAR);
		-- PROCEDURE CNS_PRODUCTES ( p_rs IN OUT sys_refcursor, p_id IN PFCBD.PRODUCTES.id%TYPE, p_joc_id IN PFCBD.PRODUCTES.JOCS_ID%TYPE, p_nom IN PFCBD.PRODUCTES.NOM%TYPE, p_tipo IN PFCBD.PRODUCTES.TIPOLOGIA%TYPE,	p_dataBaixa IN PFCBD.PRODUCTES.NOM%TYPE, p_resultat OUT VARCHAR);
				
		-- Es consulta el producte a actualitzar
		DM_PRODUCTES.CNS_PRODUCTES(v_rs, null, 1, 'Producte A', null, null, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- Actualitzaci del producte
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_record;
			  EXIT WHEN v_rs%NOTFOUND;
				 --	Actualitzaci correcta
				 DM_PRODUCTES.UPD_PRODUCTES(v_record.ID, 1, 'Producte A Actualitzat', 'VI', 0, null, v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;
 
		--	Error: Actualitzaci amb valors null
		DM_PRODUCTES.UPD_PRODUCTES(v_record.ID, null, 'Producte C', 'VI', 0, null, v_resultat);
		DM_PRODUCTES.UPD_PRODUCTES(v_record.ID, 1, null, 'VI', 0, null, v_resultat);
		DM_PRODUCTES.UPD_PRODUCTES(v_record.ID, 1, 'Producte C', null, 0, null, v_resultat);
		DM_PRODUCTES.UPD_PRODUCTES(v_record.ID, 1, 'Producte C', 'VI', null, null, v_resultat);
		
		--	Error: Actualitzaci d'un producte amb joc no existent
		DM_PRODUCTES.UPD_PRODUCTES(v_record.ID, 99, 'Producte C', 'VI', 0, null, v_resultat);
 
		--	Error: Actualitzaci d'un producte inexistent
		DM_PRODUCTES.UPD_PRODUCTES(99, 1, 'Producte C', 'VI', 0, null, v_resultat);
 
 
 		--	Error: Actualitzaci d'un producte amb tipologia incorrecta
		DM_PRODUCTES.UPD_PRODUCTES(v_record.ID, 1, 'Producte C', 'ZZ', 0, null, v_resultat);
 
 						
		-- Test BX_PRODUCTES
		-- PROCEDURE BX_PRODUCTES (p_id IN PFCBD.PRODUCTES.id%TYPE, p_dataBaixa IN PFCBD.PRODUCTES.DATABAIXA%TYPE, p_resultat OUT VARCHAR);

		-- Baixa correcta
		DM_PRODUCTES.BX_PRODUCTES(v_record.ID, null, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- Error: Baixa de producte inexistent
		DM_PRODUCTES.BX_PRODUCTES(99, null, v_resultat);
		 				
				
						 
		-- Test DEL_PRODUCTES
		-- PROCEDURE DEL_PRODUCTES (p_id IN PFCBD.PRODUCTES.id%TYPE, p_resultat OUT VARCHAR);
		
		-- Esborrat correcte
		DM_PRODUCTES.DEL_PRODUCTES ( v_record.ID, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		

		-- Error: Esborrat error producte no existeix
		DM_PRODUCTES.DEL_PRODUCTES ( 99, v_resultat);
		
		-- Error: Esborrat d'un registre amb dependncies
		DM_PRODUCTES.DEL_PRODUCTES ( 1, v_resultat);
		

		-- Test CNS_PRODUCTES
		-- PROCEDURE CNS_PRODUCTES (p_rs IN OUT sys_refcursor, 	p_id IN PFCBD.PRODUCTES.id%TYPE, p_joc_id IN PFCBD.PRODUCTES.JOCS_ID%TYPE, p_nom IN PFCBD.PRODUCTES.NOM%TYPE, p_tipo IN PFCBD.PRODUCTES.TIPOLOGIA%TYPE,	p_dataBaixa IN PFCBD.PRODUCTES.NOM%TYPE, p_resultat OUT VARCHAR);
								
		-- Consulta correcta
		DM_PRODUCTES.CNS_PRODUCTES (v_rs, null, 1, 'Producte B', null, null, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- Esborrat del producte de test creat, per no deixar dades de test a la BD.
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_record;
			  EXIT WHEN v_rs%NOTFOUND;
				 DM_PRODUCTES.DEL_PRODUCTES ( v_record.ID, v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;
 
END TEST_PRODUCTES;


END TEST_DM_PRODUCTES;


/
