---------------------------------------------------------------------------------
-- Alumne: Jessica Villamor 
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO DE VIDEOJOCS
---------------------------------------------------------------------------------

-- Procediment Test: Gesti de Provncies

--
-- Ens situem a l'esquema de la base de dades de Gesti de Videojocs
--
ALTER SESSION SET CURRENT_SCHEMA = PFCBD;

-- Creaci de la definici del paquet
Create or replace
PACKAGE PFCBD.TEST_DM_PROVINCIES AS
		
		PROCEDURE TEST_PROVINCIES;
		
	
END TEST_DM_PROVINCIES;
/

-- Creaci del cos del paquet
CREATE OR REPLACE PACKAGE BODY PFCBD.TEST_DM_PROVINCIES AS
 
    PROCEDURE TEST_PROVINCIES
    IS
		v_resultat PFCBD.LOG.RESULTAT%TYPE;
		v_rs sys_refcursor;
		v_record PROVINCIES%ROWTYPE;

    BEGIN

		-- Test INS_PROVINCIES
		-- PROCEDURE INS_PROVINCIES( p_codPais IN PFCBD.PROVINCIES.CODPAIS%TYPE, p_codProv IN PFCBD.PROVINCIES.CODPROV%TYPE, p_nom IN PFCBD.PROVINCIES.NOM%TYPE, p_resultat OUT VARCHAR);

		-- S'insereix una provncia de forma correcta
		DM_PROVINCIES.INS_PROVINCIES('ES', '90' ,'Provncia A', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- S'insereix una provncia de forma correcta
		DM_PROVINCIES.INS_PROVINCIES('ES', '91', 'Provncia B', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
	
		-- S'insereix una provncia amb un codi de pas inexistent, error d'integritat referencial
		DM_PROVINCIES.INS_PROVINCIES('00', '92', 'Provncia C', v_resultat);
			
		-- S'insereix una provncia que ja existeix
		DM_PROVINCIES.INS_PROVINCIES('ES', '91', 'Provncia D', v_resultat);
		
		-- S'insereix una provncia amb l'identificador buit
		DM_PROVINCIES.INS_PROVINCIES('', '93', 'Provncia D', v_resultat);

		-- S'insereix una provncia amb l'identificador buit
		DM_PROVINCIES.INS_PROVINCIES('ES', '', 'Provncia D', v_resultat);
		
						
				
		-- Test UPD_PROVINCIES
		-- PROCEDURE UPD_PROVINCIES ( p_codPais IN PFCBD.PROVINCIES.CODPAIS%TYPE, p_codProv IN PFCBD.PROVINCIES.CODPROV%TYPE, p_nom IN PFCBD.PROVINCIES.NOM%TYPE, p_resultat OUT VARCHAR);
		-- PROCEDURE CNS_PROVINCIES (p_rs IN OUT sys_refcursor, p_codPais IN PFCBD.PROVINCIES.CODPAIS%TYPE, p_codProv IN PFCBD.PROVINCIES.CODPROV%TYPE, p_nom  IN PFCBD.PROVINCIES.NOM%TYPE, p_resultat OUT VARCHAR);
				
		-- Es consulta la provncia a actualitzar
		DM_PROVINCIES.CNS_PROVINCIES(v_rs,'ES', '90', '', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- Actualitzaci de la provncia
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_record;
			  EXIT WHEN v_rs%NOTFOUND;
				 --	Actualitzaci correcta
				 DM_PROVINCIES.UPD_PROVINCIES('ES', '90', 'Provncia A Actualitzada', v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;
 
		-- Error: Actualitzaci amb el nom de la Provncia buida
		DM_PROVINCIES.UPD_PROVINCIES( v_record.CODPAIS, v_record.CODPROV, null, v_resultat);
		
		--	Error: Actualitzaci d'una provncia que no existeix
		DM_PROVINCIES.UPD_PROVINCIES( '99', '99', 'Provncia Inexistent', v_resultat);
 
        --	Error: Identificador no informat
		DM_PROVINCIES.UPD_PROVINCIES( null, '90', 'Provncia', v_resultat);
		DM_PROVINCIES.UPD_PROVINCIES( 'ES', null, 'Provncia', v_resultat);
		
		
		-- Test DEL_PROVINCIES
		-- PROCEDURE DEL_PROVINCIES ( p_codPais IN PFCBD.PROVINCIES.CODPAIS%TYPE, p_codProv IN PFCBD.PROVINCIES.CODPROV%TYPE, p_resultat OUT VARCHAR);
		
		-- Esborrat correcte
		DM_PROVINCIES.DEL_PROVINCIES ('ES', '90',  v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
				
		-- Error: Esborrat error provncia no existent
		DM_PROVINCIES.DEL_PROVINCIES ('99', '99',  v_resultat);
		
		-- Error: Esborrat error per identificador buit
		DM_PROVINCIES.DEL_PROVINCIES (null, '91',  v_resultat);
		DM_PROVINCIES.DEL_PROVINCIES ('ES', null,  v_resultat);
		
		-- Error: Intentar esborrar registre amb dependncies
		DM_PROVINCIES.DEL_PROVINCIES ('ES', '08',  v_resultat);
		
				
		-- Test CNS_PROVINCIES
		-- PROCEDURE CNS_PROVINCIES (p_rs IN OUT sys_refcursor, p_codPais IN PFCBD.PROVINCIES.CODPAIS%TYPE, p_codProv IN PFCBD.PROVINCIES.CODPROV%TYPE, p_nom  IN PFCBD.PROVINCIES.NOM%TYPE, p_resultat OUT VARCHAR);
			
		-- Consulta incorrecta per falta de criteris de selecci
		DM_PROVINCIES.CNS_PROVINCIES (v_rs, null, null, null, v_resultat);
		
		-- Consulta correcta
		DM_PROVINCIES.CNS_PROVINCIES (v_rs, 'ES', '91', '', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- Esborrat la provncia de test creada, per no deixar dades de test a la BD.
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_record;
			  EXIT WHEN v_rs%NOTFOUND;
				 DM_PROVINCIES.DEL_PROVINCIES (v_record.CODPAIS, v_record.CODPROV, v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;


END TEST_PROVINCIES;


END TEST_DM_PROVINCIES;


/
