---------------------------------------------------------------------------------
-- Alumne: Jessica Villamor 
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO DE VIDEOJOCS
---------------------------------------------------------------------------------

-- Procediment Test: Gesti de Xarxes Socials

--
-- Ens situem a l'esquema de la base de dades de Gesti de Videojocs
--
ALTER SESSION SET CURRENT_SCHEMA = PFCBD;

-- Creaci de la definici del paquet
Create or replace
PACKAGE PFCBD.TEST_DM_XARXESSOCIALS AS
		
		PROCEDURE TEST_XARXESSOCIALS;
		
	
END TEST_DM_XARXESSOCIALS;
/


-- Creaci del cos del paquet
CREATE OR REPLACE PACKAGE BODY PFCBD.TEST_DM_XARXESSOCIALS AS
 
    PROCEDURE TEST_XARXESSOCIALS
    IS
		v_resultat PFCBD.LOG.RESULTAT%TYPE;
		v_rs sys_refcursor;
		v_record XARXES_SOCIALS%ROWTYPE;

    BEGIN

		-- INS_XARXES_SOCIALS
		-- PROCEDURE INS_XARXES_SOCIALS(p_nom IN PFCBD.XARXES_SOCIALS.NOM%TYPE, p_resultat OUT VARCHAR);

		-- S'insereix una Xarxa Social de forma correcta
		DM_XARXESSOCIALS.INS_XARXES_SOCIALS('XARXA A', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- S'insereix una Xarxa Social de forma correcta
		DM_XARXESSOCIALS.INS_XARXES_SOCIALS('XARXA B', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- S'insereix una Xarxa Social que ja existeix
		DM_XARXESSOCIALS.INS_XARXES_SOCIALS('XARXA B', v_resultat);

		-- S'insereix una Xarxa Social amb el nom buit
		DM_XARXESSOCIALS.INS_XARXES_SOCIALS(null, v_resultat);


		-- Test UPD_XARXES_SOCIALS
		-- PROCEDURE UPD_XARXES_SOCIALS(p_id IN PFCBD.XARXES_SOCIALS.ID%TYPE, p_nom IN PFCBD.XARXES_SOCIALS.NOM%TYPE, p_resultat OUT VARCHAR);
		-- PROCEDURE CNS_XARXES_SOCIALS(p_rs IN OUT sys_refcursor, p_id IN PFCBD.XARXES_SOCIALS.ID%TYPE, p_nom IN PFCBD.XARXES_SOCIALS.NOM%TYPE, p_resultat OUT VARCHAR)
		
		-- Es consulta la Xarxa Social a actualitzar
		DM_XARXESSOCIALS.CNS_XARXES_SOCIALS (v_rs, null, 'XARXA A', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- Actualitzaci de la Xarxa Social
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_record;
			  EXIT WHEN v_rs%NOTFOUND;
				 --	Actualitzaci correcta
				 DM_XARXESSOCIALS.UPD_XARXES_SOCIALS ( v_record.ID, 'XARXA A ACT', v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;
  
		--	Error: Actualitzaci amb un nom de Xarxa Social que ja existeix
		DM_XARXESSOCIALS.UPD_XARXES_SOCIALS ( v_record.ID, 'XARXA B', v_resultat);
		
  		--	Error: Actualitzaci amb un nom de Xarxa Social buit
		DM_XARXESSOCIALS.UPD_XARXES_SOCIALS ( v_record.ID, '', v_resultat);

	     --	Error: Identificador no informat
		DM_XARXESSOCIALS.UPD_XARXES_SOCIALS (null, 'XARXA A', v_resultat);

		--	Error: Actualitzaci d'una xarxa social que no existent
		DM_XARXESSOCIALS.UPD_XARXES_SOCIALS ( 999, 'No existeix', v_resultat);
 	
		
		-- Test DEL_XARXES_SOCIALS
		-- PROCEDURE DEL_XARXES_SOCIALS(p_id IN PFCBD.XARXES_SOCIALS.ID%TYPE, p_resultat OUT VARCHAR);
		
		-- Esborrat correcte
		DM_XARXESSOCIALS.DEL_XARXES_SOCIALS (v_record.ID, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- Error: Esborrat error per identificador buit
		DM_XARXESSOCIALS.DEL_XARXES_SOCIALS  ('', v_resultat);
		
		-- Error: Esborrat error xarxa social no existent
		DM_XARXESSOCIALS.DEL_XARXES_SOCIALS (999, v_resultat);
		
		-- Error: Intentar esborrar registre amb dependncies
		DM_XARXESSOCIALS.DEL_XARXES_SOCIALS (1, v_resultat);
		

		-- Test CNS_XARXES_SOCIALS
		-- PROCEDURE CNS_XARXES_SOCIALS(p_rs IN OUT sys_refcursor, p_id IN PFCBD.XARXES_SOCIALS.ID%TYPE, p_nom IN PFCBD.XARXES_SOCIALS.NOM%TYPE, p_resultat OUT VARCHAR)
		
		-- Consulta correcta
		DM_XARXESSOCIALS.CNS_XARXES_SOCIALS (v_rs, '', 'XARXA B', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- Esborrat de les plataformes creades per no deixar dades de test a la BD.
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_record;
			  EXIT WHEN v_rs%NOTFOUND;
				 DM_XARXESSOCIALS.DEL_XARXES_SOCIALS (v_record.ID, v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;
 
END TEST_XARXESSOCIALS;


END TEST_DM_XARXESSOCIALS;


/
