---------------------------------------------------------------------------------
-- Alumne: Jessica Villamor 
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO DE VIDEOJOCS
---------------------------------------------------------------------------------

-- Procediment Test: Gesti de Joc

--
-- Ens situem a l'esquema de la base de dades de Gesti de Videojocs
--
ALTER SESSION SET CURRENT_SCHEMA = PFCBD;

Create or replace
PACKAGE PFCBD.TEST_G_GESTIO_JOCS AS
		
		PROCEDURE TEST_GESTIO_JOCS;
		
	
END TEST_G_GESTIO_JOCS;
/


CREATE OR REPLACE PACKAGE BODY PFCBD.TEST_G_GESTIO_JOCS AS
 
---------------------------------------------------------------------------------
-- Test dels procediments CU02: Gesti de Joc
---------------------------------------------------------------------------------

    PROCEDURE TEST_GESTIO_JOCS
    IS
		v_resultat PFCBD.LOG.RESULTAT%TYPE;
		v_rs sys_refcursor;
		v_recPart PARTIDES%ROWTYPE;
		
		v_Id number;
		v_IdOld number;
		v_JugadorId number;
		v_NivellId number;
		v_SegNivellId number;
		v_ProducteId number;
		v_JocId number;
		v_CODPROV  number;
		v_CODPAIS  varchar(2);
		v_CODPOB  number;
		v_Nom Varchar(255);
		v_PrimerCog  Varchar(255);
		v_SegonCog VARCHAR(255);
		v_Sexe VARCHAR(1);
		v_Act VARCHAR(1);
		v_Mail VARCHAR(255);
		v_PartidaId PFCBD.PARTIDES.ID%TYPE;
		v_vides number;
		
		
    BEGIN

		-- Test INS_JUGADORS
		-- PROCEDURE REG_JUGADOR_NIVELLS(p_rs OUT sys_refcursor, p_jugadorId IN PFCBD.NIVELLS_JUGADORS.JUGADORS_ID%TYPE,  p_jocId IN PFCBD.NIVELLS.JOCS_ID%TYPE,  p_resultat OUT VARCHAR);
		-- S'insereix un jugador per les proves
		GESTIO_USUARIS.INS_JUGADORS(null, 'ES', null, null, 'JUGADOR_A', 'PJUGA', 'JUGADOR_A', 'COG1', 'COG2', 'F', NULL, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		-- Consulta correcta
		GESTIO_USUARIS.CNS_JUGADORS_BASE (v_rs, '', 'JUGADOR_A', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		IF (v_rs IS NOT NULL) THEN
		    FETCH v_rs INTO v_JugadorId, v_CODPROV, v_CODPAIS, v_CODPOB, v_Nom, v_PrimerCog, v_SegonCog, v_Sexe, v_Mail;
			CLOSE v_rs;
		END IF;
		
		-- Consulta Nivell correcte, quan el jugador no t cap nivell registrat
		GESTIO_JOCS.REG_JUGADOR_NIVELLS(v_rs, v_JugadorId, 1, v_resultat);
		FETCH v_rs INTO  v_JocId, v_NivellId, v_Nom, v_SegNivellId;
		IF v_rs%FOUND  THEN
			DBMS_OUTPUT.put_line ('OK: Consulta amb resultats.');
		ELSE
			DBMS_OUTPUT.put_line ('KO: Consulta sense resultats.');
		END IF;
		
		-- Consulta Nivell correcte, quan el jugador ja t un nivell registrat
		GESTIO_JOCS.REG_JUGADOR_NIVELLS(v_rs, v_JugadorId, 1, v_resultat);
		FETCH v_rs INTO  v_JocId, v_NivellId, v_Nom, v_SegNivellId;
		IF v_rs%FOUND  THEN
			DBMS_OUTPUT.put_line ('OK: Consulta amb resultats.');
		ELSE
			DBMS_OUTPUT.put_line ('KO: Consulta sense resultats.');
		END IF;
		
		-- Error valors Nuls
		GESTIO_JOCS.REG_JUGADOR_NIVELLS(v_rs, null, 1, v_resultat);
		GESTIO_JOCS.REG_JUGADOR_NIVELLS(v_rs, v_JugadorId, null, v_resultat);
		
		-- Error Jugador no trobat
		GESTIO_JOCS.REG_JUGADOR_NIVELLS(v_rs, 99, 1, v_resultat);
		
		-- Error Joc no trobat
		GESTIO_JOCS.REG_JUGADOR_NIVELLS(v_rs, 1, 99, v_resultat);

				
		-- Test REG_PARTIDES_INICIAR
		-- PROCEDURE REG_PARTIDES_INICIAR(p_partidaid OUT PFCBD.PARTIDES.ID%TYPE, p_jugadorId IN PFCBD.PARTIDES.NIVJUG_JUGADORS_ID%TYPE,
	    -- 						p_nivellId IN PFCBD.PARTIDES.NIVJUG_NIVELLS_ID%TYPE, p_navegadorId IN PFCBD.NAVEGADORS.ID%TYPE,  p_plataformaId IN PFCBD.PLATAFORMES.ID%TYPE,
		--						p_data IN PFCBD.PARTIDES.DATAPARTIDA%TYPE, p_resultat OUT VARCHAR);
		
		-- Error: Parmetres obligatoris
		GESTIO_JOCS.REG_PARTIDES_INICIAR(v_PartidaId, null, 1, 1, 1, null, v_resultat);	
		GESTIO_JOCS.REG_PARTIDES_INICIAR(v_PartidaId, v_JugadorId, null, 1, 1, null, v_resultat);	
		GESTIO_JOCS.REG_PARTIDES_INICIAR(v_PartidaId, v_JugadorId, 1, null, null, null, v_resultat);	
				
		-- Error: Registre en nivell_jugadors no trobat
		GESTIO_JOCS.REG_PARTIDES_INICIAR(v_PartidaId, v_JugadorId, 2, 1, 1, null, v_resultat);				  
		
		-- Error: Navegador no trobat
		GESTIO_JOCS.REG_PARTIDES_INICIAR(v_PartidaId, v_JugadorId, 1, 99, 1, null, v_resultat);		

		-- Error: Plataforma no trobada
		GESTIO_JOCS.REG_PARTIDES_INICIAR(v_PartidaId, v_JugadorId, 1, 1, 99, null, v_resultat);		
		
		-- Iniciar partida correctament
		GESTIO_JOCS.REG_PARTIDES_INICIAR(v_PartidaId, v_JugadorId, 1, 1, 1, null, v_resultat);				  
		DBMS_OUTPUT.put_line (v_resultat);
		

		-- Test CNS_JUGADOR_VIDES
		-- PROCEDURE CNS_JUGADOR_VIDES(p_numVides OUT NUMBER, p_jugadorId IN PFCBD.JUGADORS.ID%TYPE, p_jocId IN PFCBD.JOCS.ID%TYPE,	p_data IN PFCBD.PARTIDES.DATAPARTIDA%TYPE, p_resultat OUT VARCHAR) 
 		GESTIO_JOCS.CNS_JUGADOR_VIDES(v_vides, v_JugadorId, 1, null,  v_resultat);
		if v_vides = 5 then
			DBMS_OUTPUT.put_line ('OK: Consulta realitzada correctament');
		else
			DBMS_OUTPUT.put_line ('KO: Consulta errònea');
		end if;
				
		-- Error valors nuls
		GESTIO_JOCS.CNS_JUGADOR_VIDES(v_vides, null, 1, null,  v_resultat);
		GESTIO_JOCS.CNS_JUGADOR_VIDES(v_vides, v_JugadorId, null, null,  v_resultat);
			
		-- Error Jugador no trobat
		GESTIO_JOCS.CNS_JUGADOR_VIDES(v_vides, 99, 1, null,  v_resultat);
		
		-- Error Joc no trobat
		GESTIO_JOCS.CNS_JUGADOR_VIDES(v_vides, v_JugadorId, 99, null,  v_resultat);
         
		
		-- Test CNS_JUGADOR_AJUDES
		-- PROCEDURE PROCEDURE CNS_JUGADOR_AJUDES(p_rs OUT sys_refcursor, p_jugadorId IN PFCBD.JUGADORS.ID%TYPE, p_nivellId IN PFCBD.NIVELLS.ID%TYPE, p_resultat OUT VARCHAR);
		GESTIO_JOCS.CNS_JUGADOR_AJUDES(v_rs, 1, 3, v_resultat);
		
		FETCH v_rs INTO  v_Id, v_IdOld, v_NivellId, v_ProducteId, v_Nom, v_Act;
		IF v_rs%FOUND  THEN
			DBMS_OUTPUT.put_line ('OK: Consulta amb resultats.');
		ELSE
			DBMS_OUTPUT.put_line ('KO: Consulta sense resultats.');
		END IF;
		
		-- Error parmetres obligatoris
		GESTIO_JOCS.CNS_JUGADOR_AJUDES(v_rs, null, 3, v_resultat);
		GESTIO_JOCS.CNS_JUGADOR_AJUDES(v_rs, 1, null, v_resultat);
		
		-- Error Jugador no trobat
		GESTIO_JOCS.CNS_JUGADOR_AJUDES(v_rs, 99, 1, v_resultat);
	
        -- Error Nivell no trobat
		GESTIO_JOCS.CNS_JUGADOR_AJUDES(v_rs, 1, 99, v_resultat);
	
                
		-- Test UPD_PARTIDA_CNSVIDA
		-- PROCEDURE UPD_PARTIDA_CNSVIDA(p_partidaId IN PFCBD.PARTIDES.ID%TYPE, p_resultat OUT VARCHAR);
				
		-- Error parmetres d'entrada obligatoris
		GESTIO_JOCS.UPD_PARTIDA_CNSVIDA(null, v_resultat);
		
		-- Error partida no trobada
		GESTIO_JOCS.UPD_PARTIDA_CNSVIDA(999, v_resultat);
	
		-- Consumir vida correctament 
		GESTIO_JOCS.UPD_PARTIDA_CNSVIDA(v_PartidaId, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- Es forar la consumici de totes les vides disponibles per testejar que no es pot iniciar una partida
		GESTIO_JOCS.UPD_PARTIDA_CNSVIDA(v_PartidaId, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		GESTIO_JOCS.UPD_PARTIDA_CNSVIDA(v_PartidaId, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		GESTIO_JOCS.UPD_PARTIDA_CNSVIDA(v_PartidaId, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		GESTIO_JOCS.UPD_PARTIDA_CNSVIDA(v_PartidaId, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		 
		-- Forar error, no hi ha vides disponibles intentant iniciar una partida
		GESTIO_JOCS.REG_PARTIDES_INICIAR(v_PartidaId, v_JugadorId, 1, 1, 1, null, v_resultat);		
		
				
		-- Test UPD_PARTIDA_SUPREPTE
		-- PROCEDURE UPD_PARTIDA_SUPREPTE(p_jugadorId IN PFCBD.JUGADORS.ID%TYPE, p_nivellId IN PFCBD.NIVELLS.ID%TYPE, p_resultat OUT VARCHAR);
        GESTIO_JOCS.UPD_PARTIDA_SUPREPTE(v_JugadorId, 1, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
				
		-- Error parmetres obligatoris
		GESTIO_JOCS.UPD_PARTIDA_SUPREPTE(null, 1, v_resultat);
		GESTIO_JOCS.UPD_PARTIDA_SUPREPTE(v_JugadorId, null, v_resultat);
		
		 -- Error nivell_jugadors no trobat
        GESTIO_JOCS.UPD_PARTIDA_SUPREPTE(v_JugadorId, 3, v_resultat);
						 
		
		-- Test REG_PLATAFORMES_JUGADORS
		-- PROCEDURE REG_PLATAFORMES_JUGADORS(p_plataformaId IN PFCBD.PLATAFORMES_JUGADORS.PLATAFORMES_ID%TYPE, p_jugadorId IN PFCBD.PLATAFORMES_JUGADORS.JUGADORS_ID%TYPE,
		--						  p_data IN PFCBD.PLATAFORMES_JUGADORS.DARRERACONNEXIO%TYPE, p_resultat OUT VARCHAR);
		-- Registre correcte de la plataforma utilitzada
		GESTIO_JOCS.REG_PLATAFORMES_JUGADORS(1,v_JugadorId, null, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- Error parmetres d'entrada obligatoris
		GESTIO_JOCS.REG_PLATAFORMES_JUGADORS(null,v_JugadorId, null, v_resultat);
		GESTIO_JOCS.REG_PLATAFORMES_JUGADORS(1,null, null, v_resultat);

		-- Error Jugador no trobat
		GESTIO_JOCS.REG_PLATAFORMES_JUGADORS(1,999, null, v_resultat);
		 
		-- Error Plataforma no trobada
		GESTIO_JOCS.REG_PLATAFORMES_JUGADORS(999,v_JugadorId, null, v_resultat);
			
		
		-- Test REG_NAVEGADORS_JUGADORS
		-- PROCEDURE REG_NAVEGADORS_JUGADORS(p_navegadorId IN PFCBD.NAVEGADORS_JUGADORS.NAVEGADORS_ID%TYPE, p_jugadorId IN PFCBD.NAVEGADORS_JUGADORS.JUGADORS_ID%TYPE,
		-- 									p_data IN PFCBD.NAVEGADORS_JUGADORS.DARRERACONNEXIO%TYPE, p_resultat OUT VARCHAR);
		-- Registre correcte del navegador utilitzat
		GESTIO_JOCS.REG_NAVEGADORS_JUGADORS(1, v_JugadorId, null, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- Error parmetres d'entrada obligatoris
		GESTIO_JOCS.REG_NAVEGADORS_JUGADORS(null,v_JugadorId, null, v_resultat);
		GESTIO_JOCS.REG_NAVEGADORS_JUGADORS(1,null, null, v_resultat);

		-- Error Jugador no trobat
		GESTIO_JOCS.REG_NAVEGADORS_JUGADORS(1,999, null, v_resultat);
		 
		-- Error Navegador no trobat
		GESTIO_JOCS.REG_NAVEGADORS_JUGADORS(999,v_JugadorId, null, v_resultat);
	

		ROLLBACK;
		
END TEST_GESTIO_JOCS;


END TEST_G_GESTIO_JOCS;


/
