---------------------------------------------------------------------------------
-- Alumne: Jessica Villamor 
-- Consultor: Juan Martnez Bolaos
-- Projecte: GESTIO DE VIDEOJOCS
---------------------------------------------------------------------------------

-- Procediment Test: Gesti d'Usuaris

--
-- Ens situem a l'esquema de la base de dades de Gesti de Videojocs
--
ALTER SESSION SET CURRENT_SCHEMA = PFCBD;

Create or replace
PACKAGE PFCBD.TEST_G_GESTIO_USUARIS AS
		
		PROCEDURE TEST_GESTIO_USUARIS;
		
	
END TEST_G_GESTIO_USUARIS;
/


CREATE OR REPLACE PACKAGE BODY PFCBD.TEST_G_GESTIO_USUARIS AS

---------------------------------------------------------------------------------
-- Test dels procediments CU01: Gesti d'usuari
---------------------------------------------------------------------------------
 
    PROCEDURE TEST_GESTIO_USUARIS
    IS
		v_resultat PFCBD.LOG.RESULTAT%TYPE;
		v_rs sys_refcursor;
		v_record JUGADORS_XARXES%ROWTYPE;
		
		v_id number;
		v_CODPROV  number;
		v_CODPAIS  varchar(2);
		v_CODPOB  number;
		v_Nom Varchar(255);
		v_PrimerCog  Varchar(255);
		v_SegonCog VARCHAR(255);
		v_Sexe VARCHAR(1);
		v_Mail VARCHAR(255) ;
		
    BEGIN

		
		-- Test INS_JUGADORS
		-- PROCEDURE INS_JUGADORS( p_codProv IN PFCBD.JUGADORS.CODPROV%TYPE, p_codPais IN PFCBD.JUGADORS.CODPAIS%TYPE, p_codPob IN PFCBD.JUGADORS.CODPOB%TYPE, p_dataAlta IN PFCBD.JUGADORS.DATAALTA%TYPE, 
		--				p_nomUsuari IN PFCBD.JUGADORS.NOMUSUARI%TYPE, p_contrasenya IN PFCBD.JUGADORS.CONTRASENYA%TYPE, p_nom IN PFCBD.JUGADORS.NOM%TYPE, p_primerCog IN PFCBD.JUGADORS.PRIMERCOG%TYPE, 
		--				p_segonCog IN PFCBD.JUGADORS.SEGONCOG%TYPE, p_sexe IN PFCBD.JUGADORS.SEXE%TYPE, p_mail IN PFCBD.JUGADORS.MAIL%TYPE,	p_resultat OUT VARCHAR); 

		-- S'insereix un jugador de forma correcta
		GESTIO_USUARIS.INS_JUGADORS(null, 'ES', null, null, 'JUGADOR_A', 'PJUGA', 'JUGADOR_A', 'COG1', 'COG2', 'F', NULL, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- Error: S'insereix un jugador amb el mateix nom d''usuari
		GESTIO_USUARIS.INS_JUGADORS(null, 'ES', null, null, 'JUGADOR_A', 'PJUGA', 'JUGADOR_A', 'COG1', 'COG2', 'F', NULL, v_resultat);
			
		-- Error: Inserci amb valors nuls
		GESTIO_USUARIS.INS_JUGADORS(null, null, null, null, 'JUGADOR_B', 'PJUGB', 'JUGADOR_B', 'COG1', 'COG2', 'F', NULL, v_resultat);
		GESTIO_USUARIS.INS_JUGADORS(null, 'ES', null, null, null, 'PJUGB', 'JUGADOR_B', 'COG1', 'COG2', 'F', NULL, v_resultat);
		GESTIO_USUARIS.INS_JUGADORS(null, 'ES', null, null, 'JUGADOR_B', 'PJUGB', null, 'COG1', 'COG2', 'F', NULL, v_resultat);
		GESTIO_USUARIS.INS_JUGADORS(null, 'ES', null, null, 'JUGADOR_B', 'PJUGB', 'JUGADOR_B', 'COG1', 'COG2', null, NULL, v_resultat);
					          
		-- Error: Error regla de verificaci
		GESTIO_USUARIS.INS_JUGADORS(null, 'ES', null, null, 'JUGADOR_B', 'PJUGB', 'JUGADOR_B', 'COG1', 'COG2', 'S', NULL, v_resultat);
						
		-- Error: Error integritat referencial
		GESTIO_USUARIS.INS_JUGADORS(null, '99', null, null, 'JUGADOR_B', 'PJUGB', 'JUGADOR_B', 'COG1', 'COG2', 'F', NULL, v_resultat);
                   
		-- Error: Error falta nom del jugador
		GESTIO_USUARIS.INS_JUGADORS(null, 'ES', null, null, 'JUGADOR_B', 'PJUGB', null, 'COG1', 'COG2', 'S', NULL, v_resultat);
									
						
		-- Test UPD_JUGADORS_PARAULA_PAS
		-- PROCEDURE UPD_JUGADORS_PARAULA_PAS (p_nomUsuari IN PFCBD.JUGADORS.NOMUSUARI%TYPE, p_ant_contrasenya IN PFCBD.JUGADORS.CONTRASENYA%TYPE, p_nov_contrasenya IN PFCBD.JUGADORS.CONTRASENYA%TYPE, p_resultat OUT VARCHAR); 
		-- Actualitzaci correcta de la paraula de pas
		GESTIO_USUARIS.UPD_JUGADORS_PARAULA_PAS('JUGADOR_A', 'PJUGA', 'PJUGA2', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- Actualitzaci incorrecta de la paraula de pas
		GESTIO_USUARIS.UPD_JUGADORS_PARAULA_PAS('JUGADOR_A', 'erronea', 'pass2', v_resultat);
			
		
		-- Test CNS_JUGADORS_PARAULA_PAS
		-- PROCEDURE CNS_JUGADORS_PARAULA_PAS (p_nomUsuari IN PFCBD.JUGADORS.NOMUSUARI%TYPE, p_contrasenya IN PFCBD.JUGADORS.CONTRASENYA%TYPE,	p_resultat OUT VARCHAR);
 
		-- Consulta correcta
		GESTIO_USUARIS.CNS_JUGADORS_PARAULA_PAS ('JUGADOR_A', 'PJUGA2', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- Consulta incorrecta
		GESTIO_USUARIS.CNS_JUGADORS_PARAULA_PAS ('JUGADOR_A', 'error', v_resultat);
		 
 
		-- Test UPD_JUGADORS_BASE
		-- PROCEDURE UPD_JUGADORS_BASE ( p_id IN PFCBD.JUGADORS.ID%TYPE, 
		--				p_codProv IN PFCBD.JUGADORS.CODPROV%TYPE, p_codPais IN PFCBD.JUGADORS.CODPAIS%TYPE, p_codPob IN PFCBD.JUGADORS.CODPOB%TYPE, 
		--				p_nom IN PFCBD.JUGADORS.NOM%TYPE, p_primerCog IN PFCBD.JUGADORS.PRIMERCOG%TYPE, p_segonCog IN PFCBD.JUGADORS.SEGONCOG%TYPE, 
		--				p_sexe IN PFCBD.JUGADORS.SEXE%TYPE, p_mail IN PFCBD.JUGADORS.MAIL%TYPE,	p_resultat OUT VARCHAR)
  		-- PROCEDURE CNS_JUGADORS_BASE ( p_rs IN OUT sys_refcursor, p_id IN PFCBD.JUGADORS.ID%TYPE, p_nomUsuari IN PFCBD.JUGADORS.NOMUSUARI%TYPE, p_resultat OUT VARCHAR)
		
		-- Consulta correcta
		GESTIO_USUARIS.CNS_JUGADORS_BASE (v_rs, '', 'JUGADOR_A', v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- Actualitzaci correcta
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_id, v_CODPROV, v_CODPAIS, v_CODPOB, v_Nom, v_PrimerCog, v_SegonCog, v_Sexe, v_Mail;
			  EXIT WHEN v_rs%NOTFOUND;
				 GESTIO_USUARIS.UPD_JUGADORS_BASE(v_id, null, 'ES', null, 'JUGADOR_A Act', 'Cog1 Act', 'Cog2 Act', 'F', NULL, v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;
		
		-- Error: Actualitzaci amb valors nuls
		GESTIO_USUARIS.UPD_JUGADORS_BASE(v_id, null, null, null, 'JUGADOR_A', 'COG1', 'COG2', 'F', NULL, v_resultat);
		GESTIO_USUARIS.UPD_JUGADORS_BASE(v_id, null, 'ES', null, null, 'COG1', 'COG2', 'F', NULL, v_resultat);
		GESTIO_USUARIS.UPD_JUGADORS_BASE(v_id, null, 'ES', null, 'JUGADOR_A', 'COG1', 'COG2', null, NULL, v_resultat);
		
		-- Error: Jugador no trobat
		GESTIO_USUARIS.UPD_JUGADORS_BASE(99, null, 'ES', null, 'JUGADOR_A', 'COG1', 'COG2', 'F', NULL, v_resultat);
		
		-- Error: Pas no trobat
		GESTIO_USUARIS.UPD_JUGADORS_BASE(v_id, null, '99', null, 'JUGADOR_A', 'COG1', 'COG2', 'F', NULL, v_resultat);
		
		-- Error: Provncia no trobada
		GESTIO_USUARIS.UPD_JUGADORS_BASE(v_id, 999, 'ES', null, 'JUGADOR_A', 'COG1', 'COG2', 'F', NULL, v_resultat);
		
		-- Error: Poblaci no trobada
		GESTIO_USUARIS.UPD_JUGADORS_BASE(v_id, '08', 'ES', 99999, 'JUGADOR_A', 'COG1', 'COG2', 'F', NULL, v_resultat);
		
		-- Error: Identificador buit
		GESTIO_USUARIS.UPD_JUGADORS_BASE(null, null, 'ES', null, 'JUGADOR_A', 'COG1', 'COG2', 'F', NULL, v_resultat);
				
		-- Error: Error regla de verificaci
		GESTIO_USUARIS.UPD_JUGADORS_BASE(v_id, null, 'ES', null, 'JUGADOR_A', 'Cog1 Act', 'Cog2 Act', 'S', NULL, v_resultat);
		
		-- Error: Error integritat referencial
		GESTIO_USUARIS.UPD_JUGADORS_BASE(v_id, '99', null, null, 'JUGADOR_A', 'COG1', 'COG2', 'F', NULL, v_resultat);
               
        
		-- Test INS_JUGADORS_XARXES    
		-- PROCEDURE INS_JUGADORS_XARXES( p_xarxaId IN PFCBD.JUGADORS_XARXES.XARXES_SOCIALS_ID%TYPE, p_jugadorId IN PFCBD.JUGADORS_XARXES.JUGADORS_ID%TYPE, p_nomUsuari IN PFCBD.JUGADORS_XARXES.NOMUSUARI%TYPE,
		--			 p_contrasenya IN PFCBD.JUGADORS_XARXES.CONTRASENYA%TYPE, p_dataAlta IN PFCBD.JUGADORS_XARXES.DATAALTA%TYPE, p_resultat OUT VARCHAR);				
							  
		-- Inserci correcta
		GESTIO_USUARIS.INS_JUGADORS_XARXES(1, v_id, 'jugadorA1', 'paraulapas', null,  v_resultat);					  
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- Error inserci duplicada
		GESTIO_USUARIS.INS_JUGADORS_XARXES(1, v_id, 'jugadorA1', 'paraulapasa', null,  v_resultat);					  
				
		-- Error valors nuls
		GESTIO_USUARIS.INS_JUGADORS_XARXES(null, v_id, 'jugadorA1', 'paraulapasa', null,  v_resultat);	
		GESTIO_USUARIS.INS_JUGADORS_XARXES(1, null, 'jugadorA1', 'paraulapasa', null,  v_resultat);	
		GESTIO_USUARIS.INS_JUGADORS_XARXES(1, v_id, null, 'paraulapasa', null,  v_resultat);	
		
		-- Error Integritat referencial	
		GESTIO_USUARIS.INS_JUGADORS_XARXES(99, v_id, 'usuari', 'paraulapasa', null, v_resultat);	
		GESTIO_USUARIS.INS_JUGADORS_XARXES(1, 99, 'usuari', 'paraulapasa', null, v_resultat);	
                 
		-- Test CNS_JUGADORS_XARXES
		-- PROCEDURE CNS_JUGADORS_XARXES ( p_rs OUT sys_refcursor, p_id IN PFCBD.JUGADORS_XARXES.ID%TYPE, p_xarxaId IN PFCBD.JUGADORS_XARXES.XARXES_SOCIALS_ID%TYPE, p_JugadorId IN PFCBD.JUGADORS_XARXES.JUGADORS_ID%TYPE, p_resultat OUT VARCHAR);
		-- PROCEDURE UPD_JUGADORS_XARXES( p_id IN PFCBD.JUGADORS_XARXES.ID%TYPE, p_xarxaId IN PFCBD.JUGADORS_XARXES.XARXES_SOCIALS_ID%TYPE, p_jugadorId IN PFCBD.JUGADORS_XARXES.JUGADORS_ID%TYPE, p_nomUsuari IN PFCBD.JUGADORS_XARXES.NOMUSUARI%TYPE, p_contrasenya IN PFCBD.JUGADORS_XARXES.CONTRASENYA%TYPE,  p_resultat OUT VARCHAR);

		-- Consulta correcta
		GESTIO_USUARIS.CNS_JUGADORS_XARXES (v_rs, null, 1, v_id, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);

		-- Actualitzaci correcta
		IF (v_rs IS NOT NULL)
		THEN
		   LOOP
			  FETCH v_rs INTO v_record;
			  EXIT WHEN v_rs%NOTFOUND;
				-- Actualitzaci correcta
				 GESTIO_USUARIS.UPD_JUGADORS_XARXES(v_record.ID, 1, v_id, 'jugadorA2', 'Pas2', v_resultat);
				 DBMS_OUTPUT.put_line (v_resultat);
			END LOOP;
			CLOSE v_rs;
		END IF;
		
		-- Error: Provocar un registre duplicat
		GESTIO_USUARIS.UPD_JUGADORS_XARXES(1, 1, v_id, 'jugadorA2', 'Pas2', v_resultat);
		
		-- Error: Valors nuls
		GESTIO_USUARIS.UPD_JUGADORS_XARXES(v_record.ID, 1, 1, null, 'Pas2', v_resultat);
		GESTIO_USUARIS.UPD_JUGADORS_XARXES(v_record.ID, null, 1, 'canvi', 'Pas2', v_resultat);
		GESTIO_USUARIS.UPD_JUGADORS_XARXES(v_record.ID, 1, null, 'canvi', 'Pas2', v_resultat);
		
		-- Error: Perfil no trobat
		GESTIO_USUARIS.UPD_JUGADORS_XARXES(999, 1, 1, 'canvi', 'Pas2', v_resultat);
		
		-- Error: Xarxa social no trobada
		GESTIO_USUARIS.UPD_JUGADORS_XARXES(v_record.ID, 99, 1, 'canvi', 'Pas2', v_resultat);
		
        -- Error: Jugador no trobat
		GESTIO_USUARIS.UPD_JUGADORS_XARXES(v_record.ID, 1, 99, 'canvi', 'Pas2', v_resultat);
		       
        -- Error: Identificador buit
		GESTIO_USUARIS.UPD_JUGADORS_XARXES(null, 1, 1, 'canvi', 'Pas2', v_resultat);
		  
        
		-- Test BX_JUGADORS_XARXES
        -- PROCEDURE BX_JUGADORS_XARXES( p_id IN PFCBD.JUGADORS_XARXES.ID%TYPE, p_dataBaixa IN PFCBD.JUGADORS_XARXES.DATABAIXA%TYPE, p_resultat OUT VARCHAR)        
		GESTIO_USUARIS.BX_JUGADORS_XARXES(v_record.ID, null, v_resultat);
		DBMS_OUTPUT.put_line (v_resultat);
		
		-- Error Perfil no trobat
		GESTIO_USUARIS.BX_JUGADORS_XARXES(999, null, v_resultat);
		
		-- Error Identificador buit
		GESTIO_USUARIS.BX_JUGADORS_XARXES(null, null, v_resultat);
		
		    
		ROLLBACK;

END TEST_GESTIO_USUARIS;


END TEST_G_GESTIO_USUARIS;


/
